using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;


namespace StackerBlocks
{
    public partial class GameForm1 : Form
    {
        public GameForm1()
        {
            InitializeComponent();
        }
        // @@@@@@@@@@@@@@@@@@@@@@@@@@@@ Variable section @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        int mx = 0;      // mouse location... dots
        int my = 0;
        int cnt = 0;
        int bx = 0;      // mouse location board squares 
        int by = 0;
        int oldbx = 0;
        int oldby = 0;
        int pathclear = 0;
        int r1 = 0;      // random number
        int r2 = 0;
        int start = 0;   // becomes 1 after game starts
        int cnt2 = 0;
        int tmp1 = 0;
        int move = 1;
        int movecnt = 0;
        int rowcnt = 6;
        int score = 0;
        int gameover = 0;
        int oldpiece = 1;
        Random rnd = new Random();
        int[,] brd = new int[20, 20];
        int[,] brd2 = new int[20, 20];
        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(0, 0, 40));
        static Size s1 = new Size(160, 500);
        static Bitmap bmp1 = new Bitmap(190, 500);
        static Bitmap bmp2 = new Bitmap(500, 500);
        Graphics z2 = Graphics.FromImage(bmp1);// text area
        Graphics z = Graphics.FromImage(bmp2); // main board
        //@@@@@@@@@@@@@@@@@@@@@@@@ make bitmaps @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@     
        //PaintEventArgs paint_e;
        Font myfont = new Font("Arial", 14.0F);
        Font font10 = new Font("Arial", 10.0F);
        static Bitmap bm1 = new Bitmap(47, 47);
        Graphics b1 = Graphics.FromImage(bm1);
        static Bitmap bm2 = new Bitmap(47, 47);
        Graphics b2 = Graphics.FromImage(bm2);
        static Bitmap bm3 = new Bitmap(47, 47);
        Graphics b3 = Graphics.FromImage(bm3);
        static Bitmap bm4 = new Bitmap(47, 47);
        Graphics b4 = Graphics.FromImage(bm4);
        static Bitmap bm5 = new Bitmap(47, 47);
        Graphics b5 = Graphics.FromImage(bm5);
        static Bitmap bm6 = new Bitmap(47, 47);
        Graphics b6 = Graphics.FromImage(bm6);
        static Bitmap bm7 = new Bitmap(47, 47);
        Graphics b7 = Graphics.FromImage(bm7);
        static Bitmap bm8 = new Bitmap(22, 22);
        Graphics b8 = Graphics.FromImage(bm8);
        static Bitmap bm9 = new Bitmap(22, 22);
        Graphics b9 = Graphics.FromImage(bm9);
        static Bitmap bm10 = new Bitmap(22, 22);
        Graphics b10 = Graphics.FromImage(bm10);
        static Bitmap bm11 = new Bitmap(22, 22);
        Graphics b11 = Graphics.FromImage(bm11);
        static Bitmap bm12 = new Bitmap(22, 22);
        Graphics b12 = Graphics.FromImage(bm12);

        //Image bm1 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.red));
        //Image bm2 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.blue));
        //Image bm3 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.green));
        //Image bm4 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.bluegreen));
        //Image bm5 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.pink));
        //Image bm6 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.violet));
        //Image bm7 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.R1));
        //Image bm8 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.S1));
        //Image bm9 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.T1));
        //Image bm10 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.X1));
        //Image bm11 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.Y1));
        //Image bm12 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.Z1));

        //Image bm1 = Image.FromFile("red.bmp");
        //Image bm2 = Image.FromFile("blue.bmp");
        //Image bm3 = Image.FromFile("green.bmp");
        //Image bm4 = Image.FromFile("bluegreen.bmp");
        //Image bm5 = Image.FromFile("pink.bmp");
        //Image bm6 = Image.FromFile("violet.bmp");
        //Image bm7 = Image.FromFile("R1.bmp");
        //Image bm8 = Image.FromFile("S1.bmp");
        //Image bm9 = Image.FromFile("T1.bmp");
        //Image bm10 = Image.FromFile("X1.bmp");
        //Image bm11 = Image.FromFile("Y1.bmp");
        //Image bm12 = Image.FromFile("Z1.bmp");

        // @@@@@@@@@@@@@@@@@@@@@@@@@@@ Draw Screen @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        public void MakeBitmaps()
        {
            b1.FillRectangle(Brushes.Red, 2.0F, 2.0F, 46.0F, 46.0F);
            b2.FillRectangle(Brushes.Blue, 2.0F, 2.0F, 46.0F, 46.0F);
            b3.FillRectangle(Brushes.Green, 2.0F, 2.0F, 46.0F, 46.0F);
            b4.FillRectangle(Brushes.Navy, 2.0F, 2.0F, 46.0F, 46.0F);
            b5.FillRectangle(Brushes.Purple, 2.0F, 2.0F, 46.0F, 46.0F);
            b6.FillRectangle(Brushes.Crimson, 2.0F, 2.0F, 46.0F, 46.0F);

            b7.FillRectangle(Brushes.Aqua, 0.0F, 0.0F, 22.0F, 22.0F);
            b8.FillRectangle(Brushes.Aqua, 0.0F, 0.0F, 22.0F, 22.0F);
            b9.FillRectangle(Brushes.Aqua, 0.0F, 0.0F, 22.0F, 22.0F);
            b10.FillRectangle(Brushes.Aqua, 0.0F, 0.0F, 22.0F, 22.0F);
            b11.FillRectangle(Brushes.Aqua, 0.0F, 0.0F, 22.0F, 22.0F);
            b12.FillRectangle(Brushes.Aqua, 0.0F, 0.0F, 22.0F, 22.0F);

            b7.DrawString("A", myfont, Brushes.Black, 3, 0);
            b8.DrawString("B", myfont, Brushes.Black, 3, 0);
            b9.DrawString("C", myfont, Brushes.Black, 2, 0);
            b10.DrawString("X", myfont, Brushes.Black, 3, 0);
            b11.DrawString("Y", myfont, Brushes.Black, 3, 0);
            b12.DrawString("Z", myfont, Brushes.Black, 3, 0);

            b7.DrawRectangle(new Pen(Color.Blue), 0, 0, 20, 20);
            b7.DrawRectangle(new Pen(Color.Coral), 1, 1, 19, 19);
            b8.DrawRectangle(new Pen(Color.Black), 0, 0, 20, 20);
            b8.DrawRectangle(new Pen(Color.Coral), 1, 1, 19, 19);
            b9.DrawRectangle(new Pen(Color.Blue), 0, 0, 20, 20);
            b9.DrawRectangle(new Pen(Color.Coral), 1, 1, 19, 19);
            b10.DrawRectangle(new Pen(Color.Black), 0, 0, 20, 20);
            b10.DrawRectangle(new Pen(Color.Coral), 1, 1, 19, 19);
            b11.DrawRectangle(new Pen(Color.Black), 0, 0, 20, 20);
            b11.DrawRectangle(new Pen(Color.Coral), 1, 1, 19, 19);
            b12.DrawRectangle(new Pen(Color.Black), 0, 0, 20, 20);
            b12.DrawRectangle(new Pen(Color.Coral), 1, 1, 19, 19);

        }

        public void Draw(Graphics g)
        {


            z2.FillRectangle(br1, 0.0F, 0.0F, 176.0F, 500.0F); //text
            z.FillRectangle(br2, 0.0F, 0.0F, 500.0F, 500.0F);  // Board
            Instructions();
            //z2.DrawString(mx.ToString(),myfont, Brushes.White, 10, 200);
            //z2.DrawString(oldbx.ToString(), myfont, Brushes.White, 10, 220);
            //z2.DrawString(oldby.ToString(), myfont, Brushes.White, 10, 240);
            z2.DrawString("Score  =", myfont, Brushes.White, 10, 40);
            z2.DrawString(score.ToString(), myfont, Brushes.White, 100, 40);
            if (gameover > 0) EndPrint();

            if (gameover < 1) Update();
            if (gameover < 1) DrawFrame();
            g.DrawImage(bmp1, 5, 50); // text

            g.DrawLine(new Pen(Color.Blue),178, 18, 682, 18); // draw lines around board
            g.DrawLine(new Pen(Color.Blue), 178,521, 682, 521); // bottom
            g.DrawLine(new Pen(Color.Blue), 178, 18, 178, 521); // left
            g.DrawLine(new Pen(Color.Blue), 681, 18, 681, 521); //right

            g.DrawImage(bmp2, 180, 20);
            

        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Instructions()
        {

            z2.DrawString("Click on a block to remove ", font10, Brushes.White, 0, 100);
            z2.DrawString("from the board. Click on an", font10, Brushes.White, 0, 118);
            z2.DrawString("empty square to put it back.", font10, Brushes.White, 0, 136);
            z2.DrawString("There must be a clear path", font10, Brushes.White, 0, 154);
            z2.DrawString("between the two points. You", font10, Brushes.White, 0, 172);
            z2.DrawString("score points when you get 4", font10, Brushes.White, 0, 190);
            z2.DrawString("of the same blocks in a row ", font10, Brushes.White, 0, 208);
            z2.DrawString("and they are removed from ", font10, Brushes.White, 0, 226);
            z2.DrawString("the board. ", font10, Brushes.White, 0, 244);
            z2.DrawString(" ", font10, Brushes.White, 0, 262);
            z2.DrawString(" ", font10, Brushes.White, 0, 280);
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void EndPrint()
        {
            z2.DrawString("Game Over", myfont, Brushes.White, 10, 10);
            Print("This program brought to you by:", 10, 10);
            Print("Grace Church of the Nazarene", 10, 30);
            Print("2302 Highland Avenue", 10, 50);
            Print("Columbia, Tennessee 931-388-4788", 10, 70);
            //Print " "
            //Print " "
            //Print " "
            Print("See our website at:", 10, 130);
            Print("www.columbiagrace.org", 10, 150);
            //Print " "
            //Print " "
            Print("Phillippians 4:8  NKJV", 10, 200);
            //Print
            Print("Finally, brethren, whatever things are true,", 10, 240);
            Print("whatever things are noble,whatever things are just,", 10, 260);
            Print("whatever things are pure, whatever things are lovely,", 10, 280);
            Print("whatever things are of good report, if there is any", 10, 300);
            Print("virtue and if there is anything praiseworthy -", 10, 320);
            Print(" meditate on these things.", 10, 340);

        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Print(string str, int x1, int x2)
        {

            z.DrawString(str, myfont, Brushes.White, x1, x2);
        }
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Update()
        {
            int a = 1;
            int b = 1;
            int x = 1;
            int y = 0;


            while (b < 11)
            {
                while (a < 11)
                {

                    if (brd2[a, b] == 10) { z.DrawImage(bm3, x + 1, y + 1); }

                    if (brd[a, b] == 1) { z.DrawImage(bm1, x + 1, y + 1); }
                    if (brd[a, b] == 2) { z.DrawImage(bm2, x + 1, y + 1); }
                    if (brd[a, b] == 3) { z.DrawImage(bm3, x + 1, y + 1); }
                    if (brd[a, b] == 4) { z.DrawImage(bm4, x + 1, y + 1); }
                    if (brd[a, b] == 5) { z.DrawImage(bm5, x + 1, y + 1); }
                    if (brd[a, b] == 6) { z.DrawImage(bm6, x + 1, y + 1); }
                    if (brd[a, b] == 1) { z.DrawImage(bm7, x + 14, y + 14); }
                    if (brd[a, b] == 2) { z.DrawImage(bm8, x + 14, y + 14); }
                    if (brd[a, b] == 3) { z.DrawImage(bm9, x + 14, y + 14); }
                    if (brd[a, b] == 4) { z.DrawImage(bm10, x + 14, y + 14); }
                    if (brd[a, b] == 5) { z.DrawImage(bm11, x + 14, y + 14); }
                    if (brd[a, b] == 6) { z.DrawImage(bm12, x + 14, y + 14); }
                    x = x + 50;
                    a = a + 1;
                }
                b = b + 1;
                a = 1;
                x = 0;
                y = y + 50;


            }


        }
        //@@@@@@@@@@@@@@@@@@@@@@@@ Make new row of blocks @@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void DrawFrame()
        {
            int a = 0;
            while (a < 10)
            {              // vertical lines

                z.DrawLine(new Pen(Color.Aquamarine), a * 50, 0, a * 50, 499);
                a = a + 1;
            }
            z.DrawLine(new Pen(Color.Aquamarine), 499, 0, 499, 499);
            z.DrawLine(new Pen(Color.Aquamarine), 0, 499, 499, 499);
            a = 0;
            while (a < 10)
            {              // Horizontal lines

                z.DrawLine(new Pen(Color.Aquamarine), 0, 50 * a, 499, 50 * a);
                a = a + 1;
            }
            z.DrawLine(new Pen(Color.Blue), 2, 2, 2, 498);
            z.DrawLine(new Pen(Color.Blue), 2, 2, 498, 2);
            z.DrawLine(new Pen(Color.Blue), 2, 498, 498, 498);
            z.DrawLine(new Pen(Color.Blue), 497, 498, 497, 2);
        }
        //@@@@@@@@@@@@@@@@@@@@@@ Do one time at start of program @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Start()
        {
            int x = 0;
            int y = 0;
            int a = 1;
            int b = 1;
            int c = 1;
            int d = 1;
            int a2 = 1;
            int b2 = 1;
            
            a = rnd.Next(1, 7);
            b = rnd.Next(1, 7);
            c = rnd.Next(1, 7);
            d = rnd.Next(1, 7);
            a2 = rnd.Next(1, 7);
            b2 = rnd.Next(1, 7);

            for (int i = 1; i < 6; i++)
            {
              x = rnd.Next(1, 11);
              y = rnd.Next(1, 11);
              if (i == 1) brd[x, y] = a;
              if (i == 2) brd[x, y] = b;
              if (i == 3) brd[x, y] = c;
              if (i == 4) brd[x, y] = d;
              if (i == 5) brd[x, y] = a2;
              if (i == 6) brd[x, y] = b2;
            }
            //brd[2, 3] = 4;
            start = 1;
            MakeBitmaps();
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void ScanBoard()
        {
            
            int a = 0;
            
            MarkBoard();  // clear board2 and mark it with piece numbers
            brd2[oldbx, oldby] = 10; // mark first 
            while (a < 30)
            {
                for (int y = 1; y < 11; y++)
                {
                    for (int x = 1; x < 11; x++)
                    {
                        if (brd2[x, y] == 10)
                        {
                            //if (bx == x) if (by == y) pathclear = 1;
                            if (x < 10)if(brd2[x+1,y]==0) brd2[x + 1, y] = 10;
                            if (x > 1) if(brd2[x-1,y]==0)brd2[x - 1, y] = 10;
                            if (y < 10) if (brd2[x , y+1] == 0) brd2[x, y + 1] = 10;
                            if (y > 1) if (brd2[x , y-1] == 0) brd2[x, y - 1] = 10;
                        }
                    }
                }
                a = a + 1;
            }
            
           
           
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
     
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void MarkBoard()
        {

            for (int y = 1; y < 11; y++)
            {
                for (int x = 1; x < 11; x++)
                {

                    brd2[x, y] = brd[x,y];

                }
            }
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        private void GameForm1_MouseDown(object sender, MouseEventArgs e)
        {
          
        }

        private void GameForm1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;
            bx = mx - 130;
            bx = bx / 50;
            by = (my - 20) / 50 + 1;

            r1 = rnd.Next(1, 7);
            r2 = rnd.Next(1, 7);

            cnt = 0;
            Invalidate();
            Update();
    

        }
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        private void GameForm1_Paint(object sender, PaintEventArgs e)
        {
            if (start == 0) Start();
            Draw(e.Graphics);

        }

        private void GameForm1_MouseUp(object sender, MouseEventArgs e)
        {
            if (gameover < 1)
            {
                //string a = "beep1.wav";
                Sounds.Play("beep1.wav");
                 // find pieces to remove


                if (move == 2) { ScanBoard(); PlacePiece(); }
                if (move == 3) AddPieces();
                if(move==1) RemovePiece();
                if (move == 4) points();
                if (move > 3) move = 1;
                cnt2 = cnt2 + 1;
                if (cnt2 > rowcnt)
                {
                   


                    cnt2 = 0;
                }
                if (move == 2) Gameover();
              
                Invalidate();
                Update();
            }
        }

        private void points()
        {
            int a = 0;
            for (int y = 1; y < 11; y++)
            {
                for (int x = 1; x < 11; x++)
                {
                    a = brd[x, y];
                    if (a > 0)
                    {
                        if(x<8)if (brd[x + 1, y] == a) if (brd[x + 2, y] == a) if (brd[x + 3, y] == a)
                                {
                                    brd[x + 1, y] = 0; brd[x + 2, y] = 0;
                                    brd[x + 3, y] = 0; brd[x, y] = 0; score = score + 40;
                                }
                        if(y<8)if (brd[x,y+1] == a) if (brd[x, y+2] == a) if (brd[x, y+3] == a)
                                {
                                    brd[x, y] = 0; brd[x, y+1] = 0;
                                    brd[x, y + 2] = 0; brd[x, y + 3] = 0; score = score + 40;
                                }
                        if (x < 8)if(y<8) if (brd[x + 1, y+1] == a) if (brd[x + 2, y+2] == a) if (brd[x + 3, y+3] == a)
                                {
                                    brd[x + 1, y+1] = 0; brd[x + 2, y+2] = 0;
                                    brd[x + 3, y+3] = 0; brd[x, y] = 0; score = score + 40;
                                }
                        if (y < 8)if(x>4) if (brd[x-1, y + 1] == a) if (brd[x-2, y + 2] == a) if (brd[x-3, y + 3] == a)
                                {
                                    brd[x, y] = 0; brd[x-1, y + 1] = 0;
                                    brd[x-2, y + 2] = 0; brd[x-3, y + 3] = 0; score = score + 40;
                                }


                    }
                }
            }

        }

        private void Gameover()
        {
            int a = 0;
            for (int y = 1; y < 11; y++)
            {
                for (int x = 1; x < 11; x++)
                {
                    if (brd[x,y]>0)
                    {
                        a = a + 1;  
                    }  
                }  
            }
            if (a > 95) gameover = 1;
        }
        private void AddPieces()
        {
            int x = 0;
            int y = 0;
            int a = 1;
            int b = 1;
            int c = 1;
            int d = 1;
            int a2 = 1;
            int b2 = 1;
            int a3 = 0;
            a = rnd.Next(1, 7);
            b = rnd.Next(1, 7);
            c = rnd.Next(1, 7);
            d = rnd.Next(1, 7);
            a2 = rnd.Next(1, 7);
            b2 = rnd.Next(1, 7);
            move = 4;
                for (int i = 1; i < 6; i++)
                {
                    x = rnd.Next(1, 11);
                    y = rnd.Next(1, 11);
                    if (i == 1) if (brd[x, y] == 0) { brd[x, y] = a;  }
                    if (i == 2) if (brd[x, y] == 0) { brd[x, y] = b;  }
                    if (i == 3) if (brd[x, y] == 0) { brd[x, y] = c;  }
                    if (i == 4) if (brd[x, y] == 0) { brd[x, y] = d;  }
                    if (i == 5) if (brd[x, y] == 0) { brd[x, y] = a2;  }
                    if (i == 6) if (brd[x, y] == 0) { brd[x, y] = b2;  }
                    x = rnd.Next(1, 11);
                    y = rnd.Next(1, 11);
                    if (i == 1) if (brd[x, y] == 0) { brd[x, y] = a; }
                    if (i == 2) if (brd[x, y] == 0) { brd[x, y] = b;  }
                    if (i == 3) if (brd[x, y] == 0) { brd[x, y] = c;  }
                    if (i == 4) if (brd[x, y] == 0) { brd[x, y] = d;  }
                    if (i == 5) if (brd[x, y] == 0) { brd[x, y] = a2;  }
                    if (i == 6) if (brd[x, y] == 0) { brd[x, y] = b2;  }
                    if (score > 500)
                    {
                        x = rnd.Next(1, 11);
                        y = rnd.Next(1, 11);
                        if (i == 1) if (brd[x, y] == 0) { brd[x, y] = a;  }
                        if (i == 2) if (brd[x, y] == 0) { brd[x, y] = b;  }
                        if (i == 3) if (brd[x, y] == 0) { brd[x, y] = c;  }
                        if (i == 4) if (brd[x, y] == 0) { brd[x, y] = d;  }
                        if (i == 5) if (brd[x, y] == 0) { brd[x, y] = a2; }
                        if (i == 6) if (brd[x, y] == 0) { brd[x, y] = b2;  }
                        x = rnd.Next(1, 11);
                        y = rnd.Next(1, 11);
                        if (i == 1) if (brd[x, y] == 0) { brd[x, y] = a;  }
                        if (i == 2) if (brd[x, y] == 0) { brd[x, y] = b;  }
                        if (i == 3) if (brd[x, y] == 0) { brd[x, y] = c;  }
                        if (i == 4) if (brd[x, y] == 0) { brd[x, y] = d;  }
                        if (i == 5) if (brd[x, y] == 0) { brd[x, y] = a2;  }
                        if (i == 6) if (brd[x, y] == 0) { brd[x, y] = b2; }
                    }
                    if (score > 1000)
                    {
                        x = rnd.Next(1, 11);
                        y = rnd.Next(1, 11);
                        if (i == 1) if (brd[x, y] == 0) { brd[x, y] = a; }
                        if (i == 2) if (brd[x, y] == 0) { brd[x, y] = b; }
                        if (i == 3) if (brd[x, y] == 0) { brd[x, y] = c; }
                        if (i == 4) if (brd[x, y] == 0) { brd[x, y] = d; }
                        if (i == 5) if (brd[x, y] == 0) { brd[x, y] = a2; }
                        if (i == 6) if (brd[x, y] == 0) { brd[x, y] = b2; }
                        x = rnd.Next(1, 11);
                        y = rnd.Next(1, 11);
                        if (i == 1) if (brd[x, y] == 0) { brd[x, y] = a; }
                        if (i == 2) if (brd[x, y] == 0) { brd[x, y] = b; }
                        if (i == 3) if (brd[x, y] == 0) { brd[x, y] = c; }
                        if (i == 4) if (brd[x, y] == 0) { brd[x, y] = d; }
                        if (i == 5) if (brd[x, y] == 0) { brd[x, y] = a2; }
                        if (i == 6) if (brd[x, y] == 0) { brd[x, y] = b2; }
                    }
                }
                
           
            
        }

        private void PlacePiece()
        {
            if (brd2[bx, by]== 10)//if(pathclear==1)
            {
                brd[bx, by] = oldpiece;
                oldpiece = 0;
                move = 3;
                MarkBoard();
            }
        }

        private void RemovePiece()
        {
            int a = 0;
            if(bx<10)if (brd[bx+1, by] == 0) a = 1; // do not move locked piece
            if(bx>1)if (brd[bx-1, by] == 0) a = 1;
            if(by<10)if (brd[bx, by+1] == 0) a = 1;
            if(by>1)if (brd[bx, by-1] == 0) a = 1;
            if (brd[bx, by] > 0)if(a==1)
            {
                oldpiece = brd[bx, by];
                oldbx = bx;
                oldby = by;
                brd[bx, by] = 0;
                move = 2;
            }
        }

        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    }
    //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        public class Sounds

    {
        [DllImport("WinMM.dll")]

        public static extern bool PlaySound(string fname, int Mod, int flag);

// these are the SoundFlags we are using here, check mmsystem.h for more
        public static int SND_PURGE = 0x0040; // purge non-static events
        public static int SND_ASYNC = 0x0001; // play asynchronously
        public static int SND_SYNC = 0x0000; // play synchronously (default)
        public static int SND_NODEFAULT = 0x0002; // silence (!default) if sound not found
        public static int SND_MEMORY = 0x0004; // pszSound points to a memory file
        public static int SND_LOOP = 0x0008; // loop the sound until next sndPlaySound
        public static int SND_NOSTOP = 0x0010; // don't stop any currently playing sound
        public static int SND_NOWAIT = 0x00002000; // don't wait if the driver is busy
        public static int SND_ALIAS = 0x00010000; // name is a registry alias
        public static int SND_ALIAS_ID = 0x00110000; // alias is a predefined ID
        public static int SND_FILENAME = 0x00020000; // name is file name
        public static int SND_RESOURCE = 0x00040004; // name is resource name or atom

public static void Play( string fname )
{
    //StopPlay();
    PlaySound(fname, 0, SND_ASYNC | SND_NODEFAULT | SND_FILENAME | SND_NOWAIT );
}

public static void Stop()
{
    PlaySound(null, 0, SND_PURGE);
}
}

}
