using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;


namespace StackerBlocks
{
    public partial class GameForm1 : Form
    {
        public GameForm1()
        {
            InitializeComponent();
        }
        // @@@@@@@@@@@@@@@@@@@@@@@@@@@@ Variable section @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        int mx = 0;
        int my = 0;
        int cnt = 0;
        int bx = 0;
        int by = 0;
        int r1 = 0;
        int r2 = 0;
        int start = 0;
        int cnt2 = 0;
        int tmp1 = 0;
        int movecnt = 0;
        int rowcnt = 6;
        int score = 0;
        int gameover = 0;
        Random rnd = new Random();
        int[,] brd = new int[20, 20];
        int[,] brd2 = new int[20, 20];
        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(0, 0, 40));
        static Size s1 = new Size(160, 500);
        static Bitmap bmp1 = new Bitmap(190, 500);
        static Bitmap bmp2 = new Bitmap(500, 500);
        Graphics z2 = Graphics.FromImage(bmp1);// text area
        Graphics z = Graphics.FromImage(bmp2); // main board
        //@@@@@@@@@@@@@@@@@@@@@@@@ load bitmaps @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@     
        //PaintEventArgs paint_e;
        Font myfont = new Font("Arial", 14.0F);
        Font font10 = new Font("Arial", 10.0F);
        Image bm1 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.red));
        Image bm2 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.blue));
        Image bm3 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.green));
        Image bm4 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.bluegreen));
        Image bm5 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.pink));
        Image bm6 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.violet));
        Image bm7 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.R1));
        Image bm8 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.S1));
        Image bm9 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.T1));
        Image bm10 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.X1));
        Image bm11 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.Y1));
        Image bm12 = (Image)(new Bitmap(StackerBlocks.Properties.Resources.Z1));

        //Image bm1 = Image.FromFile("red.bmp");
        //Image bm2 = Image.FromFile("blue.bmp");
        //Image bm3 = Image.FromFile("green.bmp");
        //Image bm4 = Image.FromFile("bluegreen.bmp");
        //Image bm5 = Image.FromFile("pink.bmp");
        //Image bm6 = Image.FromFile("violet.bmp");
        //Image bm7 = Image.FromFile("R1.bmp");
        //Image bm8 = Image.FromFile("S1.bmp");
        //Image bm9 = Image.FromFile("T1.bmp");
        //Image bm10 = Image.FromFile("X1.bmp");
        //Image bm11 = Image.FromFile("Y1.bmp");
        //Image bm12 = Image.FromFile("Z1.bmp");

        // @@@@@@@@@@@@@@@@@@@@@@@@@@@ Draw Screen @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        public void Draw(Graphics g)
        {


            z2.FillRectangle(br1, 0.0F, 0.0F, 160.0F, 500.0F);
            z.FillRectangle(br2, 0.0F, 0.0F, 500.0F, 500.0F);
            Instructions();
            //z2.DrawString(mx.ToString(),myfont, Brushes.White, 10, 200);
            //z2.DrawString(my.ToString(), myfont, Brushes.White, 10, 220);
            //z2.DrawString(bx.ToString(), myfont, Brushes.White, 10, 240);
            z2.DrawString("Score  =", myfont, Brushes.White, 10, 20);
            z2.DrawString(score.ToString(), myfont, Brushes.White, 100, 20);
            if (gameover > 0) EndPrint();

            if (gameover < 1) Update();
            if (gameover < 1) DrawFrame();
            g.DrawImage(bmp2, 180, 20);

            g.DrawImage(bmp1, 5, 50);
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Instructions()
        {

            z2.DrawString("Click on groups of blocks ", font10, Brushes.White, 0, 100);
            z2.DrawString("to score points.", font10, Brushes.White, 0, 118);
            z2.DrawString("Larger groups of blocks", font10, Brushes.White, 0, 136);
            z2.DrawString("score more points.", font10, Brushes.White, 0, 154);
            z2.DrawString("The game is over when the", font10, Brushes.White, 0, 172);
            z2.DrawString("blocks move to the top.", font10, Brushes.White, 0, 190);
            z2.DrawString(" ", font10, Brushes.White, 0, 208);
            z2.DrawString(" ", font10, Brushes.White, 0, 226);
            z2.DrawString(" ", font10, Brushes.White, 0, 244);
            z2.DrawString(" ", font10, Brushes.White, 0, 262);
            z2.DrawString(" ", font10, Brushes.White, 0, 280);
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void EndPrint()
        {
            z2.DrawString("Game Over", myfont, Brushes.White, 10, 30);
            Print("This program brought to you by:", 10, 10);
            Print("Grace Church of the Nazarene", 10, 30);
            Print("2302 Highland Avenue", 10, 50);
            Print("Columbia, Tennessee 931-388-4788", 10, 70);
            //Print " "
            //Print " "
            //Print " "
            Print("See our website at:", 10, 130);
            Print("www.columbiagrace.org", 10, 150);
            //Print " "
            //Print " "
            Print("Phillippians 4:8  NKJV", 10, 200);
            //Print
            Print("Finally, brethren, whatever things are true,", 10, 240);
            Print("whatever things are noble,whatever things are just,", 10, 260);
            Print("whatever things are pure, whatever things are lovely,", 10, 280);
            Print("whatever things are of good report, if there is any", 10, 300);
            Print("virtue and if there is anything praiseworthy -", 10, 320);
            Print(" meditate on these things.", 10, 340);

        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Print(string str, int x1, int x2)
        {

            z.DrawString(str, myfont, Brushes.White, x1, x2);
        }
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Update()
        {
            int a = 1;
            int b = 1;
            int x = 1;
            int y = 0;


            while (b < 11)
            {
                while (a < 11)
                {



                    if (brd[a, b] == 1) { z.DrawImage(bm1, x + 1, y + 1); }
                    if (brd[a, b] == 2) { z.DrawImage(bm2, x + 1, y + 1); }
                    if (brd[a, b] == 3) { z.DrawImage(bm3, x + 1, y + 1); }
                    if (brd[a, b] == 4) { z.DrawImage(bm4, x + 1, y + 1); }
                    if (brd[a, b] == 5) { z.DrawImage(bm5, x + 1, y + 1); }
                    if (brd[a, b] == 6) { z.DrawImage(bm6, x + 1, y + 1); }
                    if (brd[a, b] == 1) { z.DrawImage(bm7, x + 6, y + 6); }
                    if (brd[a, b] == 2) { z.DrawImage(bm8, x + 6, y + 6); }
                    if (brd[a, b] == 3) { z.DrawImage(bm9, x + 6, y + 6); }
                    if (brd[a, b] == 4) { z.DrawImage(bm10, x + 6, y + 6); }
                    if (brd[a, b] == 5) { z.DrawImage(bm11, x + 6, y + 6); }
                    if (brd[a, b] == 6) { z.DrawImage(bm12, x + 6, y + 6); }
                    x = x + 50;
                    a = a + 1;
                }
                b = b + 1;
                a = 1;
                x = 0;
                y = y + 50;


            }


        }
        //@@@@@@@@@@@@@@@@@@@@@@@@ Make new row of blocks @@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void NewRow()
        {
            int a = 0;
            int b = 0;
            // move pieces up
            for (int y = 1; y < 11; y++)
            {
                for (int x = 1; x < 11; x++)
                {
                    if (y < 10)
                    {
                        a = brd[x, y + 1];
                        brd[x, y] = a;
                    }
                }
            }
            // add row
            a = 1;
            while (a < 11)
            {
                b = rnd.Next(1, 7);
                brd[a, 10] = b;
                a = a + 1;
            }
        }


        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void DrawFrame()
        {
            int a = 0;
            while (a < 10)
            {              // vertical lines

                z.DrawLine(new Pen(Color.Aquamarine), a * 50, 0, a * 50, 499);
                a = a + 1;
            }
            z.DrawLine(new Pen(Color.Aquamarine), 499, 0, 499, 499);
            z.DrawLine(new Pen(Color.Aquamarine), 0, 499, 499, 499);
            a = 0;
            while (a < 10)
            {              // Horizontal lines

                z.DrawLine(new Pen(Color.Aquamarine), 0, 50 * a, 499, 50 * a);
                a = a + 1;
            }
            z.DrawLine(new Pen(Color.Blue), 2, 2, 2, 498);
            z.DrawLine(new Pen(Color.Blue), 2, 2, 498, 2);
            z.DrawLine(new Pen(Color.Blue), 2, 498, 498, 498);
            z.DrawLine(new Pen(Color.Blue), 497, 498, 497, 2);
        }
        //@@@@@@@@@@@@@@@@@@@@@@ Do one time at start of program @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Start()
        {
            int a = 1;
            int b = 4;
            b = rnd.Next(1, 7);
            while (a < 11)
            {
                b = rnd.Next(1, 7);
                brd[a, 10] = b;
                a = a + 1;
            }
            a = 1;
            while (a < 11)
            {
                b = rnd.Next(1, 7);
                brd[a, 9] = b;
                a = a + 1;
            }
            a = 1;
            while (a < 11)
            {
                b = rnd.Next(1, 7);
                brd[a, 8] = b;
                a = a + 1;
            }

            //brd[2, 3] = 4;
            start = 1;
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void CheckTopRow()
        {
            int a = 1;
            while (a < 11)
            {
                if (brd[a, 1] > 0) gameover = 1;
                a = a + 1;
            }

        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void ScanBoard()
        {
            int a = 0;
            tmp1 = brd[bx, by]; // get piece under mouse

            ClearBoard();  // clear board2
            brd2[bx, by] = tmp1; // mark first 
            while (a < 30)
            {
                for (int y = 1; y < 11; y++)
                {
                    for (int x = 1; x < 11; x++)
                    {
                        if (y < 11)
                        {

                            ScanBoard2(x, y);

                        }
                    }
                }
                a = a + 1;
            }
            RemovePieces();
            DropPieces();
            MovePiecesLeft();
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void MovePiecesLeft()
        {
            int a = 1;
            int b = 1;
            while (b < 10)
            {
                a = 1;
                while (a < 10)
                {
                    for (int i = 1; i < 11; i++)
                    {

                        if (brd[a, 10] == 0) if (brd[a, i] == 0)
                            {
                                brd[a, i] = brd[a + 1, i];
                                brd[a + 1, i] = 0;

                            }
                    }
                    a = a + 1;
                }
                b = b + 1;
            }
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        private void DropPieces()
        {
            int a = 0;
            int b = 0;
            while (a < 30)
            {
                for (int y = 1; y < 11; y++)
                {
                    for (int x = 1; x < 11; x++)
                    {
                        if (y < 10)
                        {
                            b = brd[x, y];
                            if (brd[x, y + 1] == 0)
                            {
                                brd[x, y + 1] = b;
                                brd[x, y] = 0;
                            }

                        }
                    }
                }
                a = a + 1;
            }
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void RemovePieces()
        {
            int sc = 0;
            for (int y = 1; y < 11; y++)
            {
                for (int x = 1; x < 11; x++)
                {

                    if (tmp1 > 0) if (brd2[x, y] == tmp1)
                        {
                            brd[x, y] = 0;
                            sc = sc + 1;
                        }

                }
            }
            //throw new Exception("The method or operation is not implemented.");
            if (sc == 1) score = score + 2;
            if (sc == 2) score = score + 5;
            if (sc == 3) score = score + 10;
            if (sc == 4) score = score + 20;
            if (sc == 5) score = score + 40;
            if (sc == 6) score = score + 80;
            if (sc == 7) score = score + 150;
            if (sc == 8) score = score + 200;
            if (sc == 9) score = score + 300;
            if (sc > 9) score = score + 400;
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void ClearBoard()
        {

            for (int y = 1; y < 11; y++)
            {
                for (int x = 1; x < 11; x++)
                {

                    brd2[x, y] = 0;

                }
            }
        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void ScanBoard2(int x, int y)
        {
            int a = 0;
            int b = 0;
            int c = 0;
            int d = 0;
            int a2 = 0;
            int b2 = 0;
            int c2 = 0;
            int d2 = 0;
            a = brd2[x, y];
            if (a == tmp1)
            {
                if (x < 10) a2 = brd[x + 1, y];
                if (y < 10) b2 = brd[x, y + 1];
                if (x > 1) c2 = brd[x - 1, y];
                if (y > 1) d2 = brd[x, y - 1];
                if (x < 10) if (a == a2) brd2[x + 1, y] = a;
                if (y < 10) if (a == b2) brd2[x, y + 1] = a;
                if (x > 1) if (a == c2) brd2[x - 1, y] = a;
                if (y > 1) if (a == d2) brd2[x, y - 1] = a;
            }

        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        private void GameForm1_MouseDown(object sender, MouseEventArgs e)
        {
          
        }

        private void GameForm1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;
            bx = mx - 130;
            bx = bx / 50;
            by = (my - 20) / 50 + 1;

            r1 = rnd.Next(1, 7);
            r2 = rnd.Next(1, 7);

            cnt = 0;
            Invalidate();
            Update();
    

        }
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        private void GameForm1_Paint(object sender, PaintEventArgs e)
        {
            if (start == 0) Start();
            Draw(e.Graphics);

        }

        private void GameForm1_MouseUp(object sender, MouseEventArgs e)
        {
            if (gameover < 1)
            {
                //string a = "beep1.wav";
                Sounds.Play("beep1.wav");
                ScanBoard(); // find pieces to remove
                cnt2 = cnt2 + 1;
                if (cnt2 > rowcnt)
                {
                    CheckTopRow();  // gameover
                    NewRow();


                    cnt2 = 0;
                }

                movecnt = movecnt + 1;   // game speed... rowcnt lower= faster game
                if (movecnt == 10) rowcnt = 5;
                if (movecnt == 30) rowcnt = 4;
                if (movecnt == 60) rowcnt = 3;
                if (movecnt == 100) rowcnt = 2;
                if (movecnt == 150) rowcnt = 1;
                Invalidate();
                Update();
            }
        }
    }
    //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        public class Sounds

    {
        [DllImport("WinMM.dll")]

        public static extern bool PlaySound(string fname, int Mod, int flag);

// these are the SoundFlags we are using here, check mmsystem.h for more
        public static int SND_PURGE = 0x0040; // purge non-static events
        public static int SND_ASYNC = 0x0001; // play asynchronously
        public static int SND_SYNC = 0x0000; // play synchronously (default)
        public static int SND_NODEFAULT = 0x0002; // silence (!default) if sound not found
        public static int SND_MEMORY = 0x0004; // pszSound points to a memory file
        public static int SND_LOOP = 0x0008; // loop the sound until next sndPlaySound
        public static int SND_NOSTOP = 0x0010; // don't stop any currently playing sound
        public static int SND_NOWAIT = 0x00002000; // don't wait if the driver is busy
        public static int SND_ALIAS = 0x00010000; // name is a registry alias
        public static int SND_ALIAS_ID = 0x00110000; // alias is a predefined ID
        public static int SND_FILENAME = 0x00020000; // name is file name
        public static int SND_RESOURCE = 0x00040004; // name is resource name or atom

public static void Play( string fname )
{
    //StopPlay();
    PlaySound(fname, 0, SND_ASYNC | SND_NODEFAULT | SND_FILENAME | SND_NOWAIT );
}

public static void Stop()
{
    PlaySound(null, 0, SND_PURGE);
}
}

}
