using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;


namespace TileSolitaire
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        #region Variables
        
        Point P1;
        int mx = 0;    // mouse horizontal pixel position
        int my = 0;    // mouse vertical position
        int bx = 0;   // column number of mouse
        int by = 0;   // row number of mouse
        int t1 = 0; int t2 = 0;
        int min = 0;
        int sec = 0;
        Random rnd = new Random();
        int game = 1;
        //int[,] brd = new int[10, 10];  // Array for holding piece information 
        int[,] brd2 = new int[10, 10]; // layer 2
        int[] set1 = new int[100]
            { 3,7,4,6,7,3,4,6,1,7,7,8,5,8,1,4,5,9,7,5,7,5,6,2,1,8,3,2,1,2,
              3,7,4,6,7,3,4,6,2,3,1,2,6,3,4,1,6,1,7,5,7,5,6,2,1,9,3,3,1,2,
              3,7,4,6,7,3,4,6,3,3,1,1,6,3,4,1,6,2,7,5,7,5,6,2,1,9,3,4,1,2,
              3,1,5,3,7,5,6,1,2,4 
            };
        int st1 = 0;   

        int gameover = 0;
        //int[,] brd = new int[10, 10]
        //  {
        //    {  10, 10, 10, 10, 10, 10, 10, 10, 10, 10 },
        //    {  10, 20, 20, 20, 20, 20, 20, 20, 20, 10 },
        //    {  10, 20, 20, 20, 20, 20, 20, 20, 20, 10 },
        //    {  10, 20, 20, 20, 20, 20, 20, 20, 20, 10 },
        //    {  10, 20, 20, 20, 1,  2,  20, 20, 20, 10 },
        //    {  10, 20, 20, 20, 3,  4,  20, 20, 20, 10 },
        //    {  10, 20, 20, 20, 20, 20, 20, 20, 20, 10 },
        //    {  10, 20, 20, 20, 20, 20, 20, 20, 20, 10 },
        //    {  10, 20, 20, 20, 20, 20, 20, 20, 20, 10 },
        //    {  10, 10, 10, 10, 10, 10, 10, 10, 10, 10 }
         //  };
        int[,] brd = new int[10, 10]
          {
            {  10, 10, 10, 10, 10, 10, 10, 10, 10, 10 },
            {  10, 20, 7, 5, 20, 20, 6, 9, 20, 10 },
            {  10, 20, 4, 7, 20, 20, 20, 20, 20, 10 },
            {  10, 20, 20, 20, 20, 20, 7, 7, 20, 10 },
            {  10, 20, 7, 8, 20, 20,  20, 20, 20, 10 },
            {  10, 20, 20, 20, 20, 20,  7, 9, 20, 10 },
            {  10, 20, 6, 7, 20, 20, 20, 20, 20, 10 },
            {  10, 20, 20, 20, 20, 20, 8, 9, 20, 10 },
            {  10, 20, 6, 8, 20, 20, 5, 9, 20, 10 },
            {  10, 10, 10, 10, 10, 10, 10, 10, 10, 10 }
           };
        #endregion
        #region Brushes
        
        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(180, 180, 220));
        Brush br3 = new SolidBrush(Color.FromArgb(20, 20, 50));
        Brush br4 = new SolidBrush(Color.LightSlateGray);
        Brush br5 = new SolidBrush(Color.DarkSlateGray);
        Brush redbr = new SolidBrush(Color.Red);
        Brush bluebr = new SolidBrush(Color.Blue);
        Brush greenbr = new SolidBrush(Color.Green);
        Brush blackbr = new SolidBrush(Color.Black);
        Brush violetbr = new SolidBrush(Color.Violet);
        Brush whitebr = new SolidBrush(Color.White);

        #endregion
        #region Pens
        
        Pen bluepen = new Pen(Color.Blue);
        Pen whitepen = new Pen(Color.White);
        Pen redpen = new Pen(Color.Red);
        Pen blackpen = new Pen(Color.Black);
        #endregion
        #region Fonts
        Font font6 = new Font("Arial",   5);
        Font font7 = new Font("Arial",   6 );
        Font font8 = new Font("Arial",   8 );
        Font font9 = new Font("Arial",   9 );
        Font font10 = new Font("Arial", 10 );
        Font font12 = new Font("Arial", 12 );
        Font font14 = new Font("Arial", 14 );
        Font font16 = new Font("Arial", 16 );
        Font font20 = new Font("Arial", 20 );
        Font font30 = new Font("Arial", 30);

        #endregion
        #region Bitmaps
        
        static Bitmap bmp1 = new Bitmap(235, 500);
        Graphics z = Graphics.FromImage(bmp1);

        static Bitmap bm0 = new Bitmap(47, 47);
        Graphics b0 = Graphics.FromImage(bm0);
        static Bitmap bm1 = new Bitmap(47, 47);
        Graphics b1 = Graphics.FromImage(bm1);
        static Bitmap bm2 = new Bitmap(47, 47);
        Graphics b2 = Graphics.FromImage(bm2);
        static Bitmap bm3 = new Bitmap(47, 47);
        Graphics b3 = Graphics.FromImage(bm3);
        static Bitmap bm4 = new Bitmap(47, 47);
        Graphics b4 = Graphics.FromImage(bm4);
        static Bitmap bm5 = new Bitmap(47, 47);
        Graphics b5 = Graphics.FromImage(bm5);
        static Bitmap bm6 = new Bitmap(47, 47);
        Graphics b6 = Graphics.FromImage(bm6);
        static Bitmap bm7 = new Bitmap(47, 47);
        Graphics b7 = Graphics.FromImage(bm7);
        static Bitmap bm8 = new Bitmap(47, 47);
        Graphics b8 = Graphics.FromImage(bm8);
        static Bitmap bm9 = new Bitmap(47, 47);
        Graphics b9 = Graphics.FromImage(bm9);

        static Bitmap bm10 = new Bitmap(47, 47);
        Graphics b10 = Graphics.FromImage(bm10);
        #endregion

        private void pic1_Click(object sender, EventArgs e)
        {
            int a = 0; int b = 0; int c = 0; int d = 0; int f = 0; int x = 0; int y = 0;
            int a1 = 0; int b1 = 0; int g = 0;
            d = set1[st1];
            #region Is move bx,by Legal? Then a=1
            
            
            if ( bx >0 && bx<9 && by>0 && by<9 && brd[by, bx] == 20  )
            {
                if (bx > 3)
                {
                    b = brd[by, bx - 1]; c = brd[by, bx - 2]; f = b + c;
                    if (f > 9) f = f - 10;
                    if (d == f && b<20 && c<20 ) a = 1;
                }
                if (bx < 7)
                {
                    b = brd[by, bx + 1]; c = brd[by, bx + 2]; f = b + c;
                    if (f > 9) f = f - 10;
                    if (d == f && b < 20 && c < 20) a = 1;
                }
                if (by > 3)
                {
                    b = brd[by - 1, bx]; c = brd[by - 2, bx]; f = b + c;
                    if (f > 9) f = f - 10;
                    if (d == f && b < 20 && c < 20) a = 1;
                }
                if (by < 7)
                {
                    b = brd[by + 1, bx]; c = brd[by + 2, bx]; f = b + c;
                    if (f > 9) f = f - 10;
                    if (d == f && b < 20 && c < 20) a = 1;
                }
            }
            #endregion
            #region If so, Put it on Board
            
            if (a == 1)
            {
                brd[by, bx] = set1[st1];
                st1 = st1 + 1;
                if (st1 > 99) st1 = 0;
            }
            #endregion
            #region Setup next move
            a = 0; b = 0; c = 0; d = 0; f = 0;
            g = set1[st1]; x = 1; y = 1; gameover = 1;
            if (st1 > 0)
            {
                while (y < 9)
                {
                    while (x < 9)
                    {
                        
                        a = brd[y, x];
                        #region is current space a vacant move location?
                        if (a == 20)
                        {
                            gameover = 0;
                            if (y < 7)
                            {
                                a1 = brd[y + 1, x];
                                b1 = brd[y + 2, x];
                                b = a1 + b1;
                                if (b < 20)
                                {
                                    if (b > 9) b = b - 10;
                                    if (g == b) c = 1;// c=1 if array has answer
                                    if (c == 0)
                                    {
                                        d = b;            // d= new possible answer
                                        t1 = a1;
                                        t2 = b1;
                                    }
                                }
                            }
                            if (y > 3)
                            {
                                a1 = brd[y - 1, x];
                                b1 = brd[y - 2, x];
                                b = a1 + b1;
                                if (b < 20)
                                {
                                    if (b > 9) b = b - 10;
                                    if (g == b) c = 1;// c=1 if array has answer
                                    if (c == 0)
                                    {
                                        d = b;           // d= new possible answer
                                        t1 = a1;
                                        t2 = b1;
                                    }
                                }
                            }
                            if (x < 7)
                            {
                                a1 = brd[y, x + 1];
                                b1 = brd[y, x + 2];
                                b = a1 + b1;
                                if (b < 20)
                                {
                                    if (b > 9) b = b - 10;
                                    if (g == b) c = 1;// c=1 if array has answer
                                    if (c == 0)
                                    {
                                        d = b;             // d= new possible answer
                                        t1 = a1;
                                        t2 = b1;
                                    }
                                }

                            }
                            if (x > 3)
                            {
                                a1 = brd[y, x - 1];
                                b1 = brd[y, x - 2];
                                b = a1 + b1;
                                if (b < 20)
                                {
                                    if (b > 9) b = b - 10;
                                    if (g == b) c = 1;// c=1 if array has answer
                                    if (c == 0)
                                    {
                                        d = b;            // d= new possible answer
                                        t1 = a1;
                                        t2 = b1;
                                    }
                                }
                            }
                        }
                        #endregion
                        x = x + 1;
                    }

                    y = y + 1;
                    x = 1;
                }
                // c=1 if array has answer
                // d= new possible answer that matches board
                
                if ( c == 0) 
                {
                    set1[st1] = d;
                   
                }
            }

            #endregion
            pic1.Invalidate();
            Invalidate();
            Update();
        }
        private void pic1_Paint(object sender, PaintEventArgs e)
        {
            
            int x = 0;
            int y = 0;
            int a = 0;
            int b = 0;
            
            #region Scan Array for Bitmap Placement
            
            
             while (a < 10)
            {
                while (b < 10) 
                {
                    if (brd[a, b] == 0)  e.Graphics.DrawImage(bm0, x, y); 
                    if (brd[a, b] == 1)  e.Graphics.DrawImage(bm1, x, y); 
                    if (brd[a, b] == 2)  e.Graphics.DrawImage(bm2, x, y); 
                    if (brd[a, b] == 3)  e.Graphics.DrawImage(bm3, x, y); 
                    if (brd[a, b] == 4)  e.Graphics.DrawImage(bm4, x, y); 
                    if (brd[a, b] == 5)  e.Graphics.DrawImage(bm5, x, y); 
                    if (brd[a, b] == 6)  e.Graphics.DrawImage(bm6, x, y); 
                    if (brd[a, b] == 7)  e.Graphics.DrawImage(bm7, x, y); 
                    if (brd[a, b] == 8)  e.Graphics.DrawImage(bm8, x, y); 
                    if (brd[a, b] == 9)  e.Graphics.DrawImage(bm9, x, y);
                    if (brd[a, b] == 10) e.Graphics.DrawImage(bm10, x, y);
                    x = x + 48;
                    b = b + 1;
                 }
                a = a + 1;
                b = 0;
                x = 0;
                y = y + 48;
            }
            #endregion
            #region Draw Picture Grid

            a = 0; x = 0; y = 0;
            while (a < 12)
            {
                e.Graphics.DrawLine(blackpen, x, 0, x, 480); // vertical
                a = a + 1;
                x = x + 48;
            }
            a = 0;
            while (a < 12)
            {
                e.Graphics.DrawLine(blackpen, 0, y, 480, y); // horizontal
                a = a + 1;
                y = y + 48;
            }
            #endregion
        }
        private void pic1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;

            bx = mx / 48;
            by = my / 48;

        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            if ( min < 5) Instructions();
            if ( min > 5) EndPrint();
            e.Graphics.DrawImage(bmp1, 10,25);                //  Text Section Background
            e.Graphics.FillRectangle(blackbr, 266, 22, 508, 508);
            e.Graphics.FillRectangle(br5, 268, 24, 504, 504); //  PicureBox Frame
            e.Graphics.FillRectangle(whitebr, 275, 31, 492, 492);
            e.Graphics.FillRectangle(redbr, 276, 32, 489, 489);
            e.Graphics.FillRectangle(br4, 278, 34, 484, 484);
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            z.FillRectangle(br3, 0, 0, 235, 500);
            MakeSprites();
            brd[5,5] = rnd.Next(1, 10);

        }

        private void Instructions()
        {
            z.DrawString(" ", font10, Brushes.White, 0, 0);
            z.DrawString(" This program is useful for addition", font10, Brushes.White, 0, 18);
            z.DrawString("practice of single digit numbers. It ", font10, Brushes.White, 0, 36);
            z.DrawString("is also useful for killing time, like ", font10, Brushes.White, 0, 54);
            z.DrawString("a game of solitaire. ", font10, Brushes.White, 0, 72);
            z.DrawString(" Click on an empty square where the  ", font10, Brushes.White, 0, 90);
            z.DrawString("number displayed below would finish ", font10, Brushes.White, 0, 108);
            z.DrawString("an addition problem. ", font10, Brushes.White, 0, 126);
            z.DrawString(" For instance the 3 on the bottom left ", font10, Brushes.White, 0, 144);
            z.DrawString("side of the screen could be put beside ", font10, Brushes.White, 0, 162);
            z.DrawString("the 1 and the 2. ", font10, Brushes.White, 0, 180);
            z.DrawString(" The problems work upwards, ", font10, Brushes.White, 0, 198);
            z.DrawString("downwards, left or right, like a ", font10, Brushes.White, 0, 216);
            z.DrawString("crossward puzzle. There are no  ", font10, Brushes.White, 0, 234);
            z.DrawString("diagonal answers. ", font10, Brushes.White, 0, 252);
            z.DrawString(" If two numbers add up to more than ", font10, Brushes.White, 0, 270);
            z.DrawString("9, just use the last digit. For instance; ", font10, Brushes.White, 0, 288);
            z.DrawString("the answer to 7+6 becomes a 3. ", font10, Brushes.White, 0, 306);
            z.DrawString(" ", font10, Brushes.White, 0, 324);
            z.DrawString(" ", font10, Brushes.White, 0, 342);
        }
        private void MakeSprites()
        {
            b0.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b1.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b2.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b3.FillRectangle(br2, 2.0F, 2.0F, 45.0F, 45.0F);
            b4.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b5.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b6.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b7.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b8.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b9.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b10.FillRectangle(br5, 2.0F, 2.0F, 46.0F, 46.0F);

            b0.DrawString("0", font30, Brushes.Black, 6, 2);
            b1.DrawString("1", font30, Brushes.Black, 6, 2);
            b2.DrawString("2", font30, Brushes.Black, 6, 2);
            b3.DrawString("3", font30, Brushes.Black, 6, 2);
            b4.DrawString("4", font30, Brushes.Black, 6, 2);
            b5.DrawString("5", font30, Brushes.Black, 6, 2);
            b6.DrawString("6", font30, Brushes.Black, 6, 2);
            b7.DrawString("7", font30, Brushes.Black, 6, 2);
            b8.DrawString("8", font30, Brushes.Black, 6, 2);
            b9.DrawString("9", font30, Brushes.Black, 6, 2);
        }
        private void Print(string str, int x1, int x2)
        {

            z.DrawString(str, font7, Brushes.White, x1, x2);
        }
        private void EndPrint()
        {

            Print("This program brought to you by:", 5, 60);
            Print("Grace Church of the Nazarene", 5, 80);
            Print("2302 Highland Avenue", 5, 100);
            Print("Columbia, Tennessee 931-388-4788", 5, 120);

            //Print " "
            //Print " "
            Print("See our website at:", 5, 150);
            Print("www.columbiagrace.org", 5, 170);
            //Print " "
            //Print " "
            Print("Phillippians 4:8  NKJV", 5, 210);
            //Print
            Print("Finally, brethren, whatever things are true,", 5, 240);
            Print("whatever things are noble,whatever things are just,", 5, 260);
            Print("whatever things are pure, whatever things are lovely,", 5, 280);
            Print("whatever things are of good report, if there is any", 5, 300);
            Print("virtue and if there is anything praiseworthy -", 5, 320);
            Print(" meditate on these things.", 5, 340);

        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            // 200 ms interval
            int a = 0;
            z.FillRectangle(br3, 0, 0, 240, 500);
            //z.DrawString(bx.ToString(), font10, Brushes.White, 20, 360);
            //z.DrawString(by.ToString(), font10, Brushes.White, 20, 380);
            //z.DrawString(t1.ToString(), font10, Brushes.White, 50, 360);
            //z.DrawString(t2.ToString(), font10, Brushes.White, 50, 380);
            z.DrawString(min.ToString(), font10, Brushes.White, 50, 360);
            z.DrawString(sec.ToString(), font10, Brushes.White, 50, 380);
            z.DrawString("minutes" , font10, Brushes.White, 100, 360);
            z.DrawString("seconds", font10, Brushes.White, 100, 380);
            #region Draw Current Piece
            a = set1[st1];
            if (a == 0) z.DrawImage(bm0, 100, 400);
            if (a == 1) z.DrawImage(bm1, 100, 400);
            if (a == 2) z.DrawImage(bm2, 100, 400);
            if (a == 3) z.DrawImage(bm3, 100, 400);
            if (a == 4) z.DrawImage(bm4, 100, 400);
            if (a == 5) z.DrawImage(bm5, 100, 400);
            if (a == 6) z.DrawImage(bm6, 100, 400);
            if (a == 7) z.DrawImage(bm7, 100, 400);
            if (a == 8) z.DrawImage(bm8, 100, 400);
            if (a == 9) z.DrawImage(bm9, 100, 400);
            #endregion
            Invalidate();
            Update();
        }
        private void timer2_Tick(object sender, EventArgs e)
        {
            if (gameover == 0)
            {
                sec = sec + 1;
                if (sec > 60)
                {
                    min = min + 1;
                    sec = 0;
                }
            }
           
        }

       
    }
    // @@@@@@@@@@@@@@@@@@@@@@@@ END OF FORM1 @@@@@@@@@@@@@@@@@@@@@@@@@@@@
    public class Sounds
    {
        [DllImport("WinMM.dll")]

        public static extern bool PlaySound(string fname, int Mod, int flag);

        // these are the SoundFlags we are using here, check mmsystem.h for more
        public static int SND_PURGE = 0x0040; // purge non-static events
        public static int SND_ASYNC = 0x0001; // play asynchronously
        public static int SND_SYNC = 0x0000; // play synchronously (default)
        public static int SND_NODEFAULT = 0x0002; // silence (!default) if sound not found
        public static int SND_MEMORY = 0x0004; // pszSound points to a memory file
        public static int SND_LOOP = 0x0008; // loop the sound until next sndPlaySound
        public static int SND_NOSTOP = 0x0010; // don't stop any currently playing sound
        public static int SND_NOWAIT = 0x00002000; // don't wait if the driver is busy
        public static int SND_ALIAS = 0x00010000; // name is a registry alias
        public static int SND_ALIAS_ID = 0x00110000; // alias is a predefined ID
        public static int SND_FILENAME = 0x00020000; // name is file name
        public static int SND_RESOURCE = 0x00040004; // name is resource name or atom

        public static void Play(string fname)
        {
            //StopPlay();
            PlaySound(fname, 0, SND_ASYNC | SND_NODEFAULT | SND_FILENAME | SND_NOWAIT);
        }

        public static void Stop()
        {
            PlaySound(null, 0, SND_PURGE);
        }
    }
}