using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;


namespace test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        #region Variables
        
        Point P1;
        int mx = 0;    // mouse horizontal pixel position
        int my = 0;    // mouse vertical position
        int bx = 0;   // column number of mouse
        int by = 0;   // row number of mouse
        Random rnd = new Random();
        //int[,] brd = new int[10, 10];  // Array for holding piece information 
        int[,] brd2 = new int[10, 10]; // layer 2
        int gameover = 0;
        int[,] brd = new int[10, 10]
          {
            {  0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
            {  0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            {  9, 8, 7, 6, 5, 4, 3, 2, 1, 0 },
            {  0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            {  0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            {  0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            {  0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            {  0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            {  0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            {  0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
           };

        #endregion
        #region Brushes
        
        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(180, 180, 220));
        Brush br3 = new SolidBrush(Color.FromArgb(20, 20, 50));
        Brush br4 = new SolidBrush(Color.LightSlateGray);
        Brush br5 = new SolidBrush(Color.DarkSlateGray);
        Brush redbr = new SolidBrush(Color.Red);
        Brush bluebr = new SolidBrush(Color.Blue);
        Brush greenbr = new SolidBrush(Color.Green);
        Brush blackbr = new SolidBrush(Color.Black);
        Brush violetbr = new SolidBrush(Color.Violet);
        Brush whitebr = new SolidBrush(Color.White);

        #endregion
        #region Pens
        
        Pen bluepen = new Pen(Color.Blue);
        Pen whitepen = new Pen(Color.White);
        Pen redpen = new Pen(Color.Red);
        Pen blackpen = new Pen(Color.Black);
        #endregion
        #region Fonts
        Font font6 = new Font("Arial",   5);
        Font font7 = new Font("Arial",   6 );
        Font font8 = new Font("Arial",   8 );
        Font font9 = new Font("Arial",   9 );
        Font font10 = new Font("Arial", 10 );
        Font font12 = new Font("Arial", 12 );
        Font font14 = new Font("Arial", 14 );
        Font font16 = new Font("Arial", 16 );
        Font font20 = new Font("Arial", 20 );
        Font font30 = new Font("Arial", 30);

        #endregion
        #region Bitmaps
        
        static Bitmap bmp1 = new Bitmap(235, 500);
        Graphics z = Graphics.FromImage(bmp1);

        static Bitmap bm0 = new Bitmap(47, 47);
        Graphics b0 = Graphics.FromImage(bm0);
        static Bitmap bm1 = new Bitmap(47, 47);
        Graphics b1 = Graphics.FromImage(bm1);
        static Bitmap bm2 = new Bitmap(47, 47);
        Graphics b2 = Graphics.FromImage(bm2);
        static Bitmap bm3 = new Bitmap(47, 47);
        Graphics b3 = Graphics.FromImage(bm3);
        static Bitmap bm4 = new Bitmap(47, 47);
        Graphics b4 = Graphics.FromImage(bm4);
        static Bitmap bm5 = new Bitmap(47, 47);
        Graphics b5 = Graphics.FromImage(bm5);
        static Bitmap bm6 = new Bitmap(47, 47);
        Graphics b6 = Graphics.FromImage(bm6);
        static Bitmap bm7 = new Bitmap(47, 47);
        Graphics b7 = Graphics.FromImage(bm7);
        static Bitmap bm8 = new Bitmap(47, 47);
        Graphics b8 = Graphics.FromImage(bm8);
        static Bitmap bm9 = new Bitmap(47, 47);
        Graphics b9 = Graphics.FromImage(bm9);

        #endregion

        private void pic1_Click(object sender, EventArgs e)
        {
            

            P1 =  PictureBox.MousePosition;
            pic1.Invalidate();
            Update();
        }
        private void pic1_Paint(object sender, PaintEventArgs e)
        {
            int x = 0;
            int y = 0;
            int a = 0;
            int b = 0;
            #region Scan Array for Bitmap Placement
            
            
             while (a < 10)
            {
                while (b < 10) 
                {
                    if (brd[a, b] == 0)  e.Graphics.DrawImage(bm0, x, y); 
                    if (brd[a, b] == 1)  e.Graphics.DrawImage(bm1, x, y); 
                    if (brd[a, b] == 2)  e.Graphics.DrawImage(bm2, x, y); 
                    if (brd[a, b] == 3)  e.Graphics.DrawImage(bm3, x, y); 
                    if (brd[a, b] == 4)  e.Graphics.DrawImage(bm4, x, y); 
                    if (brd[a, b] == 5)  e.Graphics.DrawImage(bm5, x, y); 
                    if (brd[a, b] == 6)  e.Graphics.DrawImage(bm6, x, y); 
                    if (brd[a, b] == 7)  e.Graphics.DrawImage(bm7, x, y); 
                    if (brd[a, b] == 8)  e.Graphics.DrawImage(bm8, x, y); 
                    if (brd[a, b] == 9)  e.Graphics.DrawImage(bm9, x, y); 
                    x = x + 48;
                    b = b + 1;
                 }
                a = a + 1;
                b = 0;
                x = 0;
                y = y + 48;
            }
            #endregion
            #region Picture Grid

            a = 0; x = 0; y = 0;
            while (a < 12)
            {
                e.Graphics.DrawLine(blackpen, x, 0, x, 480); // vertical
                a = a + 1;
                x = x + 48;
            }
            a = 0;
            while (a < 12)
            {
                e.Graphics.DrawLine(blackpen, 0, y, 480, y); // horizontal
                a = a + 1;
                y = y + 48;
            }
            #endregion
        }
        private void pic1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;

            bx = mx / 48;
            by = my / 48;

        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            if (gameover == 0) Instructions();
            if (gameover == 1) EndPrint();
            e.Graphics.DrawImage(bmp1, 10,25);                //  Text Section Background
            e.Graphics.FillRectangle(blackbr, 266, 22, 508, 508);
            e.Graphics.FillRectangle(br5, 268, 24, 504, 504); //  PicureBox Frame
            e.Graphics.FillRectangle(whitebr, 275, 31, 492, 492);
            e.Graphics.FillRectangle(redbr, 276, 32, 489, 489);
            e.Graphics.FillRectangle(br4, 278, 34, 484, 484);
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            z.FillRectangle(br3, 0, 0, 235, 500);
            MakeSprites();
        }

        private void Instructions()
        {

            z.DrawString("This is a test. ", font10, Brushes.White, 0, 100);
            z.DrawString(" ", font10, Brushes.White, 0, 118);
            z.DrawString(" ", font10, Brushes.White, 0, 136);
            z.DrawString(" ", font10, Brushes.White, 0, 154);
            z.DrawString(" ", font10, Brushes.White, 0, 172);
            z.DrawString(" ", font10, Brushes.White, 0, 190);
            z.DrawString(" ", font10, Brushes.White, 0, 208);
            z.DrawString(" ", font10, Brushes.White, 0, 226);
            z.DrawString(" ", font10, Brushes.White, 0, 244);
            z.DrawString(" ", font10, Brushes.White, 0, 262);
            z.DrawString(" ", font10, Brushes.White, 0, 280);
        }
        private void MakeSprites()
        {
            b1.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b2.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b3.FillRectangle(br2, 2.0F, 2.0F, 45.0F, 45.0F);
            b4.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b5.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b6.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b7.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b8.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);
            b9.FillRectangle(br2, 2.0F, 2.0F, 46.0F, 46.0F);

            b1.DrawString("1", font30, Brushes.Black, 6, 2);
            b2.DrawString("2", font30, Brushes.Black, 6, 2);
            b3.DrawString("3", font30, Brushes.Black, 6, 2);
            b4.DrawString("4", font30, Brushes.Black, 6, 2);
            b5.DrawString("5", font30, Brushes.Black, 6, 2);
            b6.DrawString("6", font30, Brushes.Black, 6, 2);
            b7.DrawString("7", font30, Brushes.Black, 6, 2);
            b8.DrawString("8", font30, Brushes.Black, 6, 2);
            b9.DrawString("9", font30, Brushes.Black, 6, 2);
        }
        private void Print(string str, int x1, int x2)
        {

            z.DrawString(str, font7, Brushes.White, x1, x2);
        }
        private void EndPrint()
        {

            Print("This program brought to you by:", 5, 60);
            Print("Grace Church of the Nazarene", 5, 80);
            Print("2302 Highland Avenue", 5, 100);
            Print("Columbia, Tennessee 931-388-4788", 5, 120);

            //Print " "
            //Print " "
            Print("See our website at:", 5, 150);
            Print("www.columbiagrace.org", 5, 170);
            //Print " "
            //Print " "
            Print("Phillippians 4:8  NKJV", 5, 210);
            //Print
            Print("Finally, brethren, whatever things are true,", 5, 240);
            Print("whatever things are noble,whatever things are just,", 5, 260);
            Print("whatever things are pure, whatever things are lovely,", 5, 280);
            Print("whatever things are of good report, if there is any", 5, 300);
            Print("virtue and if there is anything praiseworthy -", 5, 320);
            Print(" meditate on these things.", 5, 340);

        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            // 200 ms interval
            z.FillRectangle(br3, 0, 0, 220, 500);
            z.DrawString(bx.ToString(), font10, Brushes.White, 20, 360);
            z.DrawString(by.ToString(), font10, Brushes.White, 20, 380);
            z.DrawString(mx.ToString(), font10, Brushes.White, 50, 360);
            z.DrawString(my.ToString(), font10, Brushes.White, 50, 380);
            Invalidate();
            Update();
        }

       
    }
    // @@@@@@@@@@@@@@@@@@@@@@@@ END OF FORM1 @@@@@@@@@@@@@@@@@@@@@@@@@@@@
    public class Sounds
    {
        [DllImport("WinMM.dll")]

        public static extern bool PlaySound(string fname, int Mod, int flag);

        // these are the SoundFlags we are using here, check mmsystem.h for more
        public static int SND_PURGE = 0x0040; // purge non-static events
        public static int SND_ASYNC = 0x0001; // play asynchronously
        public static int SND_SYNC = 0x0000; // play synchronously (default)
        public static int SND_NODEFAULT = 0x0002; // silence (!default) if sound not found
        public static int SND_MEMORY = 0x0004; // pszSound points to a memory file
        public static int SND_LOOP = 0x0008; // loop the sound until next sndPlaySound
        public static int SND_NOSTOP = 0x0010; // don't stop any currently playing sound
        public static int SND_NOWAIT = 0x00002000; // don't wait if the driver is busy
        public static int SND_ALIAS = 0x00010000; // name is a registry alias
        public static int SND_ALIAS_ID = 0x00110000; // alias is a predefined ID
        public static int SND_FILENAME = 0x00020000; // name is file name
        public static int SND_RESOURCE = 0x00040004; // name is resource name or atom

        public static void Play(string fname)
        {
            //StopPlay();
            PlaySound(fname, 0, SND_ASYNC | SND_NODEFAULT | SND_FILENAME | SND_NOWAIT);
        }

        public static void Stop()
        {
            PlaySound(null, 0, SND_PURGE);
        }
    }
}