

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;


namespace ArrowBlocks
{
    public partial class ArrowBlocks : Form
    {
        public ArrowBlocks()
        {
            InitializeComponent();
        }



        // @@@@@@@@@@@@@@@@@@@@@@@@@@@@ Variable section @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        int mx = 0;      // mouse location... dots
        int my = 0;
        int cnt = 0;
        
        int bx = 0;      // mouse location board squares 
        int by = 0;
        int dx = 0;
        int dy = 0;
        int sprite1 = 0;
        int r1 = 0;      // random number
        int r2 = 0;
        int r3 = 0;
        int start = 0;   // becomes 1 after game starts
        int bcolor = 0;
        int cnt1 = 0;
        int cnt2 = 0;
        int move = 1;
        int dir = 0;
        int dir2 = 0;
        int mode = 1;
        int score = 0;
        int gameover = 0;
        int startx = 0;
        int starty = 0;
        int endx = 0;
        int endy = 0;
        int tx = 0;
        int ty = 0;
        
        Random rnd = new Random();
        int[,] brd = new int[20, 20];
        int[,] brd2 = new int[20, 20];
        int[,] bcnt = new int[20, 20];
        int[,] up = new int[20, 20];
        int[,] dwn = new int[20, 20];
        int[,] rt = new int[20, 20];
        int[,] lft = new int[20, 20];

        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(0, 0, 40));
        static Size s1 = new Size(160, 500);
        static Bitmap bmp1 = new Bitmap(190, 500);
        static Bitmap bmp2 = new Bitmap(500, 500);
        Graphics z2 = Graphics.FromImage(bmp1);// text area
        Graphics z = Graphics.FromImage(bmp2); // main board
        //@@@@@@@@@@@@@@@@@@@@@@@@ declare bitmaps @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@     
        //PaintEventArgs paint_e;
        Font myfont = new Font("Arial", 14.0F);
        Font font10 = new Font("Arial", 10.0F);
        //Image bm1 = (Image)(new Bitmap(Arrows.Properties.Resources.Down47));
        //Image bm2 = (Image)(new Bitmap(Arrows.Properties.Resources.LD47));
        //Image bm3 = (Image)(new Bitmap(Arrows.Properties.Resources.Left47));
        //Image bm4 = (Image)(new Bitmap(Arrows.Properties.Resources.LU47));
        //Image bm5 = (Image)(new Bitmap(Arrows.Properties.Resources.RD47));
        //Image bm6 = (Image)(new Bitmap(Arrows.Properties.Resources.Right47));
        //Image bm7 = (Image)(new Bitmap(Arrows.Properties.Resources.RU47));
        //Image bm8 = (Image)(new Bitmap(Arrows.Properties.Resources.Up47));

        static Bitmap bm1 = new Bitmap(35, 35);
        Graphics b1 = Graphics.FromImage(bm1);
        static Bitmap bm2 = new Bitmap(35, 35);
        Graphics b2 = Graphics.FromImage(bm2);
        static Bitmap bm3 = new Bitmap(35, 35);
        Graphics b3 = Graphics.FromImage(bm3);
        static Bitmap bm4 = new Bitmap(35, 35);
        Graphics b4 = Graphics.FromImage(bm4);
        static Bitmap bm5 = new Bitmap(35, 35);
        Graphics b5 = Graphics.FromImage(bm5);
        static Bitmap bm6 = new Bitmap(35, 35);
        Graphics b6 = Graphics.FromImage(bm6);


        static Bitmap bm7 = new Bitmap(35, 35);
        Graphics b7 = Graphics.FromImage(bm7);
        static Bitmap bm8 = new Bitmap(35,35 );
        Graphics b8 = Graphics.FromImage(bm8);
        static Bitmap bm9 = new Bitmap(35,35 );
        Graphics b9 = Graphics.FromImage(bm9);
        static Bitmap bm10 = new Bitmap(35,35 );
        Graphics b10 = Graphics.FromImage(bm10);
        //static Bitmap bm11 = new Bitmap(35,35 );
        //Graphics b11 = Graphics.FromImage(bm11);
        //static Bitmap bm12 = new Bitmap(35, 35);
        //Graphics b12 = Graphics.FromImage(bm12);

        // @@@@@@@@@@@@@@@@@@@@@@@@@@@ Draw Screen @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    


        public void Draw(Graphics g)
        {

            
            //z2.FillRectangle(br1, 0.0F, 0.0F, 176.0F, 500.0F); //text
            //z.FillRectangle(br2, 0.0F, 0.0F, 500.0F, 500.0F);  // Board
            //if (gameover < 1) Update();
            //if (gameover < 1) DrawFrame();
            //Instructions();
            //z2.DrawString(mx.ToString(),myfont, Brushes.White, 10, 400);
            //z2.DrawString(my.ToString(), myfont, Brushes.White, 10, 420);
            //z2.DrawString(bx.ToString(), myfont, Brushes.White, 10, 440);
            //z2.DrawString(by.ToString(), myfont, Brushes.White, 10, 460);

            //z2.DrawString("Score  =", myfont, Brushes.White, 10, 40);
            //z2.DrawString(score.ToString(), myfont, Brushes.White, 100, 40);
            if (gameover > 0) EndPrint();

            if (gameover < 1) Update();
            if (gameover < 1) DrawFrame();
            g.DrawImage(bmp1, 5, 50); // text

            g.DrawLine(new Pen(Color.Blue), 178, 18, 681, 18); // draw lines around board
            g.DrawLine(new Pen(Color.Blue), 178, 521, 681, 521); // bottom
            g.DrawLine(new Pen(Color.Blue), 178, 18, 178, 521); // left
            g.DrawLine(new Pen(Color.Blue), 681, 18, 681, 521); //right

            g.DrawImage(bmp2, 180, 20);// board
             //if (gameover < 1) Update();
             //if (gameover < 1) DrawFrame();

        }

        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Instructions()
        {

            z2.DrawString("Click on an arrow block to ", font10, Brushes.White, 0, 100);
            z2.DrawString("move it. If it stops near ", font10, Brushes.White, 0, 118);
            z2.DrawString("another center piece of the", font10, Brushes.White, 0, 136);
            z2.DrawString("same color, both will ", font10, Brushes.White, 0, 154);
            z2.DrawString("be removed from the board.", font10, Brushes.White, 0, 172);
            z2.DrawString(" The game is over when the", font10, Brushes.White, 0, 190);
            z2.DrawString("center squares have had all  ", font10, Brushes.White, 0, 208);
            z2.DrawString("their pieces removed. ", font10, Brushes.White, 0, 226);
            z2.DrawString("Like golf the best score is   ", font10, Brushes.White, 0, 244);
            z2.DrawString("the lowest score. ", font10, Brushes.White, 0, 262);
            z2.DrawString(" ", font10, Brushes.White, 0, 280);
        }

        private void EndPrint()
        {
            z.FillRectangle(br2, 0.0F, 0.0F, 500.0F, 500.0F);  //  Eraise Board
            z2.DrawString("Game Over", myfont, Brushes.White, 10, 10);
            Print("This program brought to you by:", 10, 10);
            Print("Grace Church of the Nazarene", 10, 30);
            Print("2302 Highland Avenue", 10, 50);
            Print("Columbia, Tennessee 931-388-4788", 10, 70);
            //Print " "
            //Print " "
            //Print " "
            Print("See our website at:", 10, 130);
            Print("www.columbiagrace.org", 10, 150);
            //Print " "
            //Print " "
            Print("Phillippians 4:8  NKJV", 10, 200);
            //Print
            Print("Finally, brethren, whatever things are true,", 10, 240);
            Print("whatever things are noble,whatever things are just,", 10, 260);
            Print("whatever things are pure, whatever things are lovely,", 10, 280);
            Print("whatever things are of good report, if there is any", 10, 300);
            Print("virtue and if there is anything praiseworthy -", 10, 320);
            Print(" meditate on these things.", 10, 340);

        }

        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Print(string str, int x1, int x2)
        {

            z.DrawString(str, myfont, Brushes.White, x1, x2);
        }
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void UpdateBoard()
        {
            int a = 1;
            int b = 1;
            int c = 0;
            int d = 0;
            int x = 4;
            int y = 4;
            z.FillRectangle(br2, 0.0F, 0.0F, 500.0F, 500.0F);  //  Eraise Board
            if (gameover < 1)
            {
                while (b < 15)
                {
                    while (a < 15)
                    {
                        
                        if (brd[a, b] == 1) { z.DrawImage(bm1, x , y ); } // sprites
                        if (brd[a, b] == 2) { z.DrawImage(bm2, x , y ); }
                        if (brd[a, b] == 3) { z.DrawImage(bm3, x , y ); }
                        if (brd[a, b] == 4) { z.DrawImage(bm4, x , y ); }
                        if (brd[a, b] == 5) { z.DrawImage(bm5, x , y ); }
                        if (brd[a, b] == 6) { z.DrawImage(bm6, x , y ); }

                        if (brd2[a, b] == 7) { z.DrawImage(bm7, x , y ); }
                        if (brd2[a, b] == 8) { z.DrawImage(bm8, x , y ); }
                        if (brd2[a, b] == 9) { z.DrawImage(bm9, x, y); }
                        if (brd2[a, b] == 10) { z.DrawImage(bm10, x, y); }

                        x = x + 35;
                        a = a + 1;
                    }
                    b = b + 1;
                    a = 1;
                    x = 4;
                    y = y + 35;


                }
                x = 100;  // draw extra piece
                y = 20;
                //z.DrawImage(bm1, x + 100, y + 1);
            }
            if (sprite1 == 1) { z.DrawImage(bm1, x + 1, y + 1); } // colors
            if (sprite1 == 2) { z.DrawImage(bm2, x + 1, y + 1); }
            if (sprite1 == 3) { z.DrawImage(bm3, x + 1, y + 1); }
            if (sprite1 == 4) { z.DrawImage(bm4, x + 1, y + 1); }
            if (sprite1 == 5) { z.DrawImage(bm5, x + 1, y + 1); }
            if (sprite1 == 6) { z.DrawImage(bm6, x + 1, y + 1); }
            if (sprite1 == 7) { z.DrawImage(bm7, x + 1, y + 1); }
            if (sprite1 == 8) { z.DrawImage(bm8, x + 1, y + 1); }
            if (cnt == 49) gameover = 1;

        }
        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
       //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void DrawFrame()
        {
            int a = 0;
            while (a < 15)
            {              // vertical lines

                z.DrawLine(new Pen(Color.Aquamarine), (a * 35) + 4, 4, a * 35 + 4, 494);
                a = a + 1;
            }
            //z.DrawLine(new Pen(Color.Aquamarine), 499, 0, 499, 499);
            //z.DrawLine(new Pen(Color.Aquamarine), 0, 499, 499, 499);
            a = 0;
            while (a < 15)
            {              // Horizontal lines

                z.DrawLine(new Pen(Color.Aquamarine), 4, 35 * a + 4, 494, 35 * a + 4);
                a = a + 1;
            }
            z.DrawLine(new Pen(Color.Blue), 2, 2, 2, 498); // left
            z.DrawLine(new Pen(Color.Blue), 2, 2, 497, 2); // top
            z.DrawLine(new Pen(Color.Blue), 2, 498, 497, 498); // bottom
            z.DrawLine(new Pen(Color.Blue), 497, 498, 497, 2); // right

            //z.DrawLine(new Pen(Color.Blue), 48, 48, 48, 452); // left
           // z.DrawLine(new Pen(Color.Blue), 48, 48, 452, 48); // top
            //z.DrawLine(new Pen(Color.Blue), 48, 452, 452, 452); // bottom
            //z.DrawLine(new Pen(Color.Blue), 452, 48, 452, 452); // right

           // z.DrawLine(new Pen(Color.Red), 46, 46, 46, 454); // left
           // z.DrawLine(new Pen(Color.Red), 46, 46, 454, 46); // top
           // z.DrawLine(new Pen(Color.Red), 46, 454, 454, 454); // bottom
           // z.DrawLine(new Pen(Color.Red), 454, 46, 454, 454); // right

        }
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void DrawFrame2()
        {
            int a = 0;
            while (a < 7)
            {              // vertical lines

                z.DrawLine(new Pen(Color.Aquamarine), (a * 50)+100,100, a * 50+100, 400);
                a = a + 1;
            }
            //z.DrawLine(new Pen(Color.Aquamarine), 499, 0, 499, 499);
            //z.DrawLine(new Pen(Color.Aquamarine), 0, 499, 499, 499);
            a = 0;
            while (a < 7)
            {              // Horizontal lines

                z.DrawLine(new Pen(Color.Aquamarine),100, 50 * a+100, 400, 50 * a+100);
                a = a + 1;
            }
            z.DrawLine(new Pen(Color.Blue), 2, 2, 2, 498); // left
            z.DrawLine(new Pen(Color.Blue), 2, 2, 497, 2); // top
            z.DrawLine(new Pen(Color.Blue), 2, 498, 497, 498); // bottom
            z.DrawLine(new Pen(Color.Blue), 497, 498, 497, 2); // right

            z.DrawLine(new Pen(Color.Blue), 98, 98, 98, 402); // left
            z.DrawLine(new Pen(Color.Blue), 98, 98, 402, 98); // top
            z.DrawLine(new Pen(Color.Blue), 98, 402, 402, 402); // bottom
            z.DrawLine(new Pen(Color.Blue), 402, 98, 402, 402); // right

            z.DrawLine(new Pen(Color.Red), 96, 96, 96, 404); // left
            z.DrawLine(new Pen(Color.Red), 96, 96, 404, 96); // top
            z.DrawLine(new Pen(Color.Red), 96, 404, 404, 404); // bottom
            z.DrawLine(new Pen(Color.Red), 404, 96, 404, 404); // right

        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;
            bx = mx - 184;
            bx = (bx / 35)+1;
            by = (my - 24) / 35+1 ;

            if (bx > 13) bx = 14;
            if (by > 13) by = 14;
            if (bx < 2) bx = 1;
            if (by < 2) by = 1;

            dx = bx + 1;
            dy = by + 1;
            if (dx < 2) dx = 1;
            if (dy < 2) dy = 1;
            if (dx > 8) dx = 8;
            if (dy > 8) dy = 8;
            r1 = rnd.Next(1, 7);
            r2 = rnd.Next(1, 7);

            UpdateText();
            Invalidate();
            Update();


        }
        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            if (start == 0) Start();
            //Draw(e.Graphics);

            if (gameover > 0) EndPrint();

            //if (gameover < 1) Update();
            //if (gameover < 1) DrawFrame();
            e.Graphics.DrawImage(bmp1, 5, 50); // text

            e.Graphics.DrawLine(new Pen(Color.Blue), 178, 18, 681, 18); // draw lines around board
            e.Graphics.DrawLine(new Pen(Color.Blue), 178, 521, 681, 521); // bottom
            e.Graphics.DrawLine(new Pen(Color.Blue), 178, 18, 178, 521); // left
            e.Graphics.DrawLine(new Pen(Color.Blue), 681, 18, 681, 521); //right

            e.Graphics.DrawImage(bmp2, 180, 20);// board
            
        }
        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            
            
            if (gameover < 1)
            {
               
                Sounds.Play("beep1.wav");
                //brd[bx, by] = 1;
                    MakeMove();
                    UpdateText();
                    UpdateBoard();
                    DrawFrame();
                    Gameover();
                    score = score + 1;
                }
                Invalidate();
                Update();
           

        }

        private void MakeMove()
        {
           
          
            int a = 0;
            int b = 0;
            int c = 0;
            int d = 0;
            int e = 0;
            int f = 0;
            int g = 0;
            a = brd2[bx, by]; //Arrow number
            bcolor = brd[bx, by]; // block color
            startx = bx;
            starty = by;
            
            
            if (a == 7)if(brd[bx-1, by]==0) MoveLeft();
            if (a == 8) if (brd[bx + 1, by] == 0) MoveRight();
            if (a == 9) if (brd[bx , by+1] == 0) MoveDown();
            if (a == 10) if (brd[bx , by-1] == 0) MoveUp();
            
        }

        private void MoveUp()
        {
            int a = by-1;
            int b = 0;
            int c = 0;
            dir = 10;
            startx = bx;
            starty = a;
            endx = bx;
            tx = bx ;  // temp x
            ty = by-1;
            timer1.Start();
            r1 = rnd.Next(1, 7);
            while (a > 2)
            {

                b = brd[bx, a];
                if (b == 0) endy = a;
                if (b > 0) a = 2;
                a = a - 1;
            }
            if (by == 13)    // replace moved pieces
            {
                brd[bx, 13] = brd[bx, 14];
                brd2[bx, 13] = brd2[bx, 14];
                brd[bx, 14] = r1;
            }
        }

        private void MoveDown()
        {
            int a = by+1;
            int b = 0;
            int c = 0;
            dir = 9;
            startx = bx;
            starty = by+1;
            endx = bx;
            tx = bx ;  // temp x
            ty = by+1;
            timer1.Start();
            r1 = rnd.Next(1, 7);
            while (a <13)
            {

                b = brd[bx, a];
                if (b == 0) endy = a;
                if (b > 0) a = 13;
                a = a + 1;
            }
            if (by == 2)    // replace moved pieces
            {
                brd[bx, 2] = brd[bx, 1];
                brd2[bx, 2] = brd2[bx, 1];
                brd[bx, 1] = r1;
            }
        }

        private void MoveRight()
        {
            int a = bx+1;
            int b = 0;
            int c = 0;
            dir = 8;
            startx = a;
            starty = by;
            endy = by;
            tx = bx + 1;  // temp x
            ty = by;
            timer1.Start();
            r1 = rnd.Next(1, 7);
            while (a < 13)
            {

                b = brd[a, by];
                if (b == 0) endx = a;
                if (b > 0) a = 13;
                a = a + 1;
            }
            if (bx == 2)    // replace moved pieces
            {
                brd[2, by] = brd[1, by];
                brd2[2, by] = brd2[1, by];
                brd[1, by] = r1;
            }
        }

        private void MoveLeft()
        {
            int a = bx-1;
            int b = 0;
            int c = 0;
            dir = 7;
            startx = a;
            starty = by;
            endy = by;
            tx = bx-1;  // temp x
            ty = by;
            timer1.Start();
            r1 = rnd.Next(1, 7);
            while (a > 2)
            {
                
                b = brd[a, by];
                if (b ==0) endx = a;
                if (b > 0) a = 2;
                a = a - 1;
            }
            if (bx == 13)    // replace moved pieces
            {
                brd[13, by] = brd[14, by];
                brd2[13, by] = brd2[14, by];
                brd[14, by] = r1;
            }
        }

       


        private void points()
        {
            int a = 0;
           

        }


        //@@@@@@@@@@@@@@@@@@@@@@ Do one time at start of program @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        //@@@@@@@@@@@@@@@@@@@@@@ Do one time at start of program @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        private void Start()
        {
            int a = 1;
            int b = 3;
            int x = 0;
            int y = 0;
            timer1.Enabled = true;
            timer1.Interval = 100;
            timer1.Stop();
            timer2.Enabled = true;
            timer2.Interval = 100;
            timer2.Stop();
            // place arrows
             while (b < 13)
             {
                 brd2[13, b] = 7;// left
                 brd2[14, b] = 7;
                 brd2[ 1, b] = 8;//right
                 brd2[ 2, b] = 8;
                 brd2[b, 13] = 10;//up
                 brd2[b, 14] = 10;
                 brd2[b, 1] = 9;//down
                 brd2[b, 2] = 9;
                 b = b + 1;
             }
             b = 4;
             while (b < 12) //make center arrows
             {
                 brd2[11, b] = 7;
                 brd2[4, b] = 8;
                 brd2[b, 4] = 9;
                 brd2[b, 11] = 10;
                 b = b + 1;
             }
             b = 0;
             while (b < 25)
             {
                 r1 = rnd.Next(7, 11);
                 x = rnd.Next(5, 11);
                 y = rnd.Next(5, 11);
                 brd2[x, y] = r1;
                 b = b + 1;
             }
            // make blocks
             b1.FillRectangle(Brushes.Red, 0.0F, 0.0F, 35.0F, 35.0F);
             b2.FillRectangle(Brushes.Green, 0.0F, 0.0F, 35.0F, 35.0F);
             b3.FillRectangle(Brushes.Blue, 0.0F, 0.0F, 35.0F, 35.0F);
             b4.FillRectangle(Brushes.YellowGreen, 0.0F, 0.0F, 35.0F, 35.0F);
             b5.FillRectangle(Brushes.Orange, 0.0F, 0.0F, 35.0F, 35.0F);
             b6.FillRectangle(Brushes.Purple, 0.0F, 0.0F, 35.0F, 35.0F);

             b1.DrawRectangle(new Pen(Color.Gray), 1, 1, 33, 33);
             b1.DrawRectangle(new Pen(Color.Black), 3, 3, 29, 29);
             b2.DrawRectangle(new Pen(Color.Blue), 1, 1, 33, 33);
             b2.DrawRectangle(new Pen(Color.Black), 3, 3, 29, 29);
             b3.DrawRectangle(new Pen(Color.Red), 1, 1, 33, 33);
             b3.DrawRectangle(new Pen(Color.Black), 3, 3, 29, 29);
             b4.DrawRectangle(new Pen(Color.Purple), 1, 1, 33, 33);
             b4.DrawRectangle(new Pen(Color.Black), 3, 3, 29, 29);
             b5.DrawRectangle(new Pen(Color.Red), 1, 1, 33, 33);
             b5.DrawRectangle(new Pen(Color.Black), 3, 3, 29, 29);
             b6.DrawRectangle(new Pen(Color.Gray), 1, 1, 33, 33);
             b6.DrawRectangle(new Pen(Color.Black), 3, 3, 29, 29);

            // b7.FillRectangle(Brushes.Purple, 0.0F, 0.0F, 35.0F, 35.0F);
            // b8.FillRectangle(Brushes.Pink, 0.0F, 0.0F, 35.0F, 35.0F);
            // b2.FillRectangle(Brushes.Green, 2.0F, 2.0F, 46.0F, 46.0F);
           // b1.FillEllipse(Brushes.Red, 12, 10, 25, 25);
           // b2.FillEllipse(Brushes.Green, 12, 10, 25, 25);
             MakeArrows();
             MakeBoard();
           

            start = 1;

            UpdateText();
            UpdateBoard();
            DrawFrame();
        }

        private void MakeArrows()
        {

            b7.FillRectangle(Brushes.Gray, 10.0F, 13.0F, 20.0F, 8.0F); // left
            b7.DrawRectangle(new Pen(Color.Black), 10, 13, 20, 7);
            b7.DrawLine(new Pen(Color.Black), 6, 16, 14, 8);
            
            b7.DrawLine(new Pen(Color.Black), 6, 17, 14, 25);
            b7.DrawLine(new Pen(Color.Black), 14, 8, 14, 25);// vertical side of triangle
            b7.FillPolygon(Brushes.Gray, // triangle head of arrow
                new Point[] { new Point(7, 17), new Point(14, 25), new Point(14, 8) });

            b7.DrawLine(new Pen(Color.Gray), 14, 14, 14, 19); // vertical side of triangle
            b7.DrawLine(new Pen(Color.Gray), 10, 13, 10,18); // cover spot

            b7.DrawLine(new Pen(Color.Blue), 13, 15, 29, 15);
            b7.DrawLine(new Pen(Color.Blue), 13, 18, 29, 18);

            b7.DrawLine(new Pen(Color.Blue), 13, 15, 13, 11);
            b7.DrawLine(new Pen(Color.Blue), 13, 18, 13, 22);

            b7.DrawLine(new Pen(Color.Blue), 8, 16, 13, 11);
            b7.DrawLine(new Pen(Color.Blue), 8, 17, 13, 22);

            b7.DrawLine(new Pen(Color.Blue), 29, 15, 29, 18);
//@@@@@@@@@@@@

            b8.FillRectangle(Brushes.Gray, 5.0F, 13.0F, 20.0F, 8.0F); // Right
            b8.DrawRectangle(new Pen(Color.Black), 5, 13, 20, 7);
            b8.DrawLine(new Pen(Color.Black), 29, 16, 21, 8);

            b8.DrawLine(new Pen(Color.Black), 29, 17, 21, 25);
            b8.DrawLine(new Pen(Color.Black), 20, 8, 20, 25);// vertical side of triangle
            b8.FillPolygon(Brushes.Gray, // triangle head of arrow
                new Point[] { new Point(28, 17), new Point(21, 25), new Point(21, 8) });

            b8.DrawLine(new Pen(Color.Gray), 20, 14, 20, 19); // vertical side of triangle
            b8.DrawLine(new Pen(Color.Gray), 25, 13, 25, 18); // cover spot

            b8.DrawLine(new Pen(Color.Blue), 22, 15, 6, 15);
            b8.DrawLine(new Pen(Color.Blue), 22, 18, 6, 18);

            b8.DrawLine(new Pen(Color.Blue), 22, 15, 22, 11);
            b8.DrawLine(new Pen(Color.Blue), 22, 18, 22, 22);

            b8.DrawLine(new Pen(Color.Blue), 27, 16, 22, 11);
            b8.DrawLine(new Pen(Color.Blue), 27, 17, 22, 22);

            b8.DrawLine(new Pen(Color.Blue), 6, 15, 6, 18);
   //@@@@@@@@@@@@@@@@@@@@@@
            b9.FillRectangle(Brushes.Gray, 13.0F, 5.0F, 8.0F, 20.0F); // Down
            b9.DrawRectangle(new Pen(Color.Black), 13, 5, 7, 20);
            b9.DrawLine(new Pen(Color.Black), 16, 29, 8, 21);

            b9.DrawLine(new Pen(Color.Black), 17, 29, 25, 21);
            b9.DrawLine(new Pen(Color.Black), 8, 20, 25, 20);// vertical side of triangle
            b9.FillPolygon(Brushes.Gray, // triangle head of arrow
                new Point[] { new Point(17, 28), new Point(25, 21), new Point(8,21) });

            b9.DrawLine(new Pen(Color.Gray), 14, 20, 19, 20); // vertical side of triangle
            b9.DrawLine(new Pen(Color.Gray), 13, 25, 18, 25); // cover spot

            b9.DrawLine(new Pen(Color.Blue), 15, 22, 15, 6);
            b9.DrawLine(new Pen(Color.Blue), 18, 22, 18, 6);

            b9.DrawLine(new Pen(Color.Blue), 15, 22, 11, 22);
            b9.DrawLine(new Pen(Color.Blue), 18, 22, 22, 22);

            b9.DrawLine(new Pen(Color.Blue), 16, 27, 11, 22);
            b9.DrawLine(new Pen(Color.Blue), 17, 27, 22, 22);

            b9.DrawLine(new Pen(Color.Blue), 15, 6, 18, 6);
//@@@@@@@@@@@@@@@@@
            b10.FillRectangle(Brushes.Gray, 13.0F, 10.0F, 8.0F, 20.0F); // up
            b10.DrawRectangle(new Pen(Color.Black), 13, 10, 7, 20);
            b10.DrawLine(new Pen(Color.Black), 16, 6, 8, 14);// large diagonals

            b10.DrawLine(new Pen(Color.Black), 17, 6, 25, 14);
            b10.DrawLine(new Pen(Color.Black), 8, 14, 25, 14);// vertical side of triangle
            b10.FillPolygon(Brushes.Gray, // triangle head of arrow
                new Point[] { new Point(17, 7), new Point(25, 14), new Point(8,14) });

            b10.DrawLine(new Pen(Color.Gray), 14, 14, 19, 14); // vertical side of triangle
            b10.DrawLine(new Pen(Color.Gray), 13, 10, 18, 10); // cover spot

            b10.DrawLine(new Pen(Color.Blue), 15, 13, 15, 29);
            b10.DrawLine(new Pen(Color.Blue), 18, 13, 18, 29);

            b10.DrawLine(new Pen(Color.Blue), 15, 13, 11, 13);
            b10.DrawLine(new Pen(Color.Blue), 18, 13, 22, 13);

            b10.DrawLine(new Pen(Color.Blue), 16, 8, 11, 13); // small diagonals
            b10.DrawLine(new Pen(Color.Blue), 17, 8, 22, 13);

            b10.DrawLine(new Pen(Color.Blue), 15, 29, 18, 29);
        }

        private void MakeBoard()
        {
            
            int r1 = 0;
            int a = 1;

            for (int x = 1; x < 15; x++)
            {
                for (int y = 1; y < 15; y++)
                {
                    r1 = rnd.Next(1, 7);

                    if (brd[x, y] == 0) a = a + 1;
                    brd[x, y] = r1; // sprite numbers
                    if (x == 3) if (y > 2) if (y < 13) brd[x, y] = 0;
                    if (x == 12) if (y > 2) if (y < 13) brd[x, y] = 0;
                    if (y == 3) if (x > 2) if (x < 13) brd[x, y] = 0;
                    if (y == 12) if (x > 2) if (x < 13) brd[x, y] = 0;
             
                }
            } 

               
        }


       

        private void UpdateText()
        {
            z2.FillRectangle(br1, 0.0F, 0.0F, 176.0F, 500.0F); //text
            
            //if (gameover < 1) Update();
            //if (gameover < 1) DrawFrame();
            Instructions();
           // z2.DrawString(cnt2.ToString(), myfont, Brushes.White, 10, 380);
           // z2.DrawString(tx.ToString(), myfont, Brushes.White, 10, 400);
           // z2.DrawString(ty.ToString(), myfont, Brushes.White, 10, 420);
           // z2.DrawString(endx.ToString(), myfont, Brushes.White, 10, 440);
           // z2.DrawString(endy.ToString(), myfont, Brushes.White, 10, 460);

            z2.DrawString("Score  =", myfont, Brushes.White, 10, 40);
            z2.DrawString(score.ToString(), myfont, Brushes.White, 100, 40); 
        }



        private void Gameover()
        {
            int a = 0;
            
            for (int y = 3; y < 13; y++)
            {
                for (int x = 3; x < 13; x++)
                {
                    if (brd[x, y] == 0)
                    {
                        a = a + 1;
                    }
                }
            }
            if (a > 98) gameover = 1;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            
            cnt1 = cnt1 + 1;
                   // animation
                
                if (cnt1 > 90) cnt1 = 0;
                if (cnt == 12)
                {
                    cnt = 0;
                    timer1.Stop();
                    if (dir == 7)
                    {
                        brd[3, ty] = 0;
                        brd2[3, ty] = 0;
                    }
                    if (dir == 8)
                    {
                        brd[12, ty] = 0;
                        brd2[12, ty] = 0;
                    }
                    if (dir == 9)
                    {
                        brd[tx, 12] = 0;
                        brd2[tx, 12] = 0;
                    }
                    if (dir == 10)
                    {
                        brd[tx, 3] = 0;
                        brd2[tx, 3] = 0;
                    }
                    
                }

                if (dir == 7)if(endx-1<tx)// left
                {
                    brd2[tx, ty] = 7; // make new arrow
                    brd[tx, ty] = bcolor; // make new square
                    if(tx<12)brd2[tx+1, ty] = 0; // take out old arrow
                    if (tx < 12) brd[tx + 1, ty] = 0; // take out old square
                    tx = tx - 1;      // go to next square
                    if (tx < endx)    // last square
                    {
                        //dir2 = dir;
                        //dir = 0;
                        //cnt1 = 0;
                        timer1.Stop();
                        tx = tx + 1;
                        
                        timer2.Start();
                        
                    }
                   
                    
                }
            if (dir == 8) if (endx + 1 > tx) //right
                {
                    brd2[tx, ty] = 8;
                    brd[tx, ty] = bcolor;
                    if(tx>3)brd2[tx - 1, ty] = 0; // take out old arrow
                    if(tx>3)brd[tx - 1, ty] = 0; // take out old square

                    tx = tx + 1;
                    if (tx > endx)
                    {
                        //dir = 0;
                        //cnt1 = 0;
                        timer1.Stop();
                        tx=tx-1;
                        
                        timer2.Start();
                    }


                }
            if (dir == 9) if (endy + 1 > ty) //down
                {
                    brd2[tx, ty] = 9;
                    brd[tx, ty] = bcolor;
                    if(ty>3)brd2[tx , ty-1] = 0; // take out old arrow
                    if(ty>3)brd[tx , ty-1] = 0; // take out old square
                    ty = ty + 1;
                    if (ty > endy)
                    {
                        //dir = 0;
                        //cnt1 = 0;
                        timer1.Stop();
                        ty=ty-1;
                        
                        timer2.Start();
                    }


                }
            if (dir == 10) if (endy - 1 < ty) // up
                {
                    brd2[tx, ty] = 10;
                    brd[tx, ty] = bcolor;
                    if(ty<12)brd2[tx, ty + 1] = 0; // take out old arrow
                    if(ty<12)brd[tx, ty + 1] = 0; // take out old square
                    ty = ty - 1;
                    if (ty < endy)
                    {
                        //dir = 0;
                        //cnt1 = 0;
                        timer1.Stop();
                        ty=ty+1;
                        
                        timer2.Start();
                    }


                }
            //timer1.Stop();
           //if(cnt2==60) timer1.Enabled = false;
            UpdateText();
            UpdateBoard();
            DrawFrame();
            Invalidate();
            Update();
        }
        private void RemovePieces()
        {
            int a = 0;
            int b = 0;
            int c = 0;
            int d = 0;
            int e = 0;
            int f = 0;
            int g = 0;
            a = brd[tx, ty];    
            b = brd[tx+1 , ty]; // right
            c = brd[tx-1, ty];  // left
            d = brd[tx, ty+1];  // down
            e = brd[tx, ty-1];  // up
            if (a == b)if(tx<12) // right
            {
                brd[tx, ty] = 0;
                brd2[tx, ty] = 0;
                brd[tx+1, ty] = 0;
                brd2[tx+1, ty] = 0;
            }
            if (a == c)if(tx>3) //left
            {
                brd[tx, ty] = 0;
                brd2[tx, ty] = 0;
                brd[tx-1, ty] = 0;
                brd2[tx-1, ty] = 0;
            }
            if (a == d)if(ty<12)
            {
                brd[tx, ty] = 0;
                brd2[tx, ty] = 0;
                brd[tx, ty+1] = 0;
                brd2[tx, ty+1] = 0;
            }
            if (a == e)if(ty>3)
            {
                brd[tx, ty] = 0;
                brd2[tx, ty] = 0;
                brd[tx, ty-1] = 0;
                brd2[tx, ty-1] = 0;
            }
           
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            cnt2 = cnt2 + 1;
            if (cnt2 == 3)
            {
                cnt2 = 0;
                RemovePieces();
                timer2.Stop();
                
                    if (dir == 7)
                    {
                        brd[3, ty] = 0;
                        brd2[3, ty] = 0;
                    }
                    if (dir == 8)
                    {
                        brd[12, ty] = 0;
                        brd2[12, ty] = 0;
                    }
                    if (dir == 9)
                    {
                        brd[tx, 12] = 0;
                        brd2[tx, 12] = 0;
                    }
                    if (dir == 10)
                    {
                        brd[tx, 3] = 0;
                        brd2[tx, 3] = 0;
                    }

                


            }
            UpdateText();
            UpdateBoard();
            DrawFrame();
            Invalidate();
            Update();
        }

       
     


        //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  

    }
    //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
    public class Sounds
    {
        [DllImport("WinMM.dll")]

        public static extern bool PlaySound(string fname, int Mod, int flag);

        // these are the SoundFlags we are using here, check mmsystem.h for more
        public static int SND_PURGE = 0x0040; // purge non-static events
        public static int SND_ASYNC = 0x0001; // play asynchronously
        public static int SND_SYNC = 0x0000; // play synchronously (default)
        public static int SND_NODEFAULT = 0x0002; // silence (!default) if sound not found
        public static int SND_MEMORY = 0x0004; // pszSound points to a memory file
        public static int SND_LOOP = 0x0008; // loop the sound until next sndPlaySound
        public static int SND_NOSTOP = 0x0010; // don't stop any currently playing sound
        public static int SND_NOWAIT = 0x00002000; // don't wait if the driver is busy
        public static int SND_ALIAS = 0x00010000; // name is a registry alias
        public static int SND_ALIAS_ID = 0x00110000; // alias is a predefined ID
        public static int SND_FILENAME = 0x00020000; // name is file name
        public static int SND_RESOURCE = 0x00040004; // name is resource name or atom

        public static void Play(string fname)
        {
            //StopPlay();
            PlaySound(fname, 0, SND_ASYNC | SND_NODEFAULT | SND_FILENAME | SND_NOWAIT);
        }

        public static void Stop()
        {
            PlaySound(null, 0, SND_PURGE);
        }
    }



}