using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;

namespace Sudoku
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        #region Variable Section
        
        
        int mx = 0;    // mouse horizontal pixel position
        int my = 0;    // mouse vertical position
        int bx = 0;   // column number of mouse
        int by = 0;   // row number of mouse
        int ch = 0;
        int bx2 = 0;   
        int by2 = 0;
        int bx3 = 0;
        int by3 = 0;
        int bx4 = 0;
        int by4 = 1;
        int bsize = 48; // square size
        int cnt = 0;
        int r1 = 1;  // random numbers or holders of array data
        int r2 = 2;
        int gameover = 0;
        int score = 0;
        Random rnd = new Random();
        //int[,] brd = new int[60, 60];  // Array for holding piece information
        int[,] brd = new int[10, 10]

          {
            { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
            { 0, 5, 7, 4, 1, 8, 2, 3, 6, 9 },
            { 0, 8, 3, 1, 5, 6, 9, 4, 2, 7 },
            { 0, 2, 9, 6, 7, 3, 4, 5, 8, 1 },
            { 0, 1, 4, 9, 6, 2, 3, 7, 5, 8 },
            { 0, 6, 5, 2, 8, 4, 7, 9, 1, 3 },
            { 0, 7, 8, 3, 9, 1, 5, 6, 4, 2 },
            { 0, 4, 1, 7, 3, 5, 8, 2, 9, 6 },
            { 0, 9, 6, 5, 2, 7, 1, 8, 3, 4 },
            { 0, 3, 2, 8, 4, 9, 6, 1, 7, 5 }
          };

        int[,] brd2 = new int[10, 10]; // layer 2
        int[,] brd3 = new int[10, 10]; // layer 3
        int[,] brd4 = new int[10, 10]; // layer 4
        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(20, 20, 50));
        Brush br3 = new SolidBrush(Color.FromArgb(0, 0, 250));
        Brush br4 = new SolidBrush(Color.LightSlateGray);
        Brush br5 = new SolidBrush(Color.DarkSlateGray);
        Brush redbr = new SolidBrush(Color.Red);

        Font myfont = new Font("Arial", 12.0F);
        Font font5 = new Font("Arial", 5.0F);
        Font font6 = new Font("Arial", 6.0F);
        Font font7 = new Font("Arial", 7.0F);
        Font font8 = new Font("Arial", 8.0F);
        Font font10 = new Font("Arial", 10.0F);
        Font font30 = new Font("Arial", 30.0F);
        Pen bluepen = new Pen(Color.Blue);
        Pen blackpen = new Pen(Color.Black);
        Pen darkbluepen = new Pen(Color.DarkBlue);
        Pen whitepen = new Pen(Color.White);
        Pen redpen = new Pen(Color.Red);
        #endregion
        #region Bitmap Section


        static Bitmap bmp1 = new Bitmap(800, 600);
        Graphics z = Graphics.FromImage(bmp1);

        static Bitmap bm1 = new Bitmap(45, 45);
        Graphics b1 = Graphics.FromImage(bm1);
        static Bitmap bm2 = new Bitmap(45, 45);
        Graphics b2 = Graphics.FromImage(bm2);
        static Bitmap bm3 = new Bitmap(45, 45);
        Graphics b3 = Graphics.FromImage(bm3);
        static Bitmap bm4 = new Bitmap(45, 45);
        Graphics b4 = Graphics.FromImage(bm4);
        static Bitmap bm5 = new Bitmap(45, 45);
        Graphics b5 = Graphics.FromImage(bm5);
        static Bitmap bm6 = new Bitmap(45, 45);
        Graphics b6 = Graphics.FromImage(bm6);
        static Bitmap bm7 = new Bitmap(45, 45);
        Graphics b7 = Graphics.FromImage(bm7);
        static Bitmap bm8 = new Bitmap(45, 45);
        Graphics b8 = Graphics.FromImage(bm8);
        static Bitmap bm9 = new Bitmap(45, 45);
        Graphics b9 = Graphics.FromImage(bm9);
        static Bitmap bm10 = new Bitmap(48, 48);
        Graphics b10 = Graphics.FromImage(bm10);
        static Bitmap bm11 = new Bitmap(48, 48);
        Graphics b11 = Graphics.FromImage(bm11);
        
        #endregion

        private void Form1_Load(object sender, EventArgs e)
        {
            int a = 5;
            r1 = rnd.Next(1, 6);
            a = r1;
            r2 = rnd.Next(1, 7);
            ShufflePieces();
            #region Start Data
            
            
            if (a == 1)
            {
                brd2[1,1 ] = brd[1,1 ]; brd2[2,1 ] = brd[2,1 ]; brd2[1,3 ] = brd[1,3 ];
                brd2[3,4 ] = brd[3,4 ]; brd2[3,5 ] = brd[3,5 ]; brd2[2,6 ] = brd[2,6 ];
                brd2[2,7 ] = brd[2,7 ]; brd2[3,7 ] = brd[3,7 ]; brd2[2, 9] = brd[2,9 ];
                brd2[3,9 ] = brd[3,9 ]; brd2[5,1 ] = brd[5,1 ]; brd2[6,1 ] = brd[6,1 ];
                brd2[5,2 ] = brd[5,2 ]; brd2[5,3 ] = brd[5,3 ]; brd2[6,4 ] = brd[6,4 ];
                brd2[5,7 ] = brd[5,7 ]; brd2[5,8 ] = brd[5,8 ]; brd2[6,8 ] = brd[6,8 ];
                brd2[5,9 ] = brd[5,9 ]; brd2[6,9 ] = brd[6,9 ]; brd2[8,1 ] = brd[8,1 ];
                brd2[7,2 ] = brd[7,2 ]; brd2[9,3 ] = brd[9,3 ]; brd2[8,4 ] = brd[8,4 ];
                brd2[9,4 ] = brd[9,4 ]; brd2[7,5 ] = brd[7,5 ]; brd2[8,5 ] = brd[8,5 ];
                brd2[8,6 ] = brd[8,6 ]; brd2[9,8 ] = brd[9,8 ]; brd2[7,9 ] = brd[7,9 ];
                brd2[9,9 ] = brd[9,9 ]; 
               // brd2[ ] = brd[ ];   brd2[ ] = brd[  ];   brd2[ ] = brd[ ];
            }
            if(a==2)
            {
                brd2[1,1 ] = brd[1,1 ];   brd2[2,1 ] = brd[2,1 ];   brd2[2,3 ] = brd[2,3 ];
                brd2[3,3 ] = brd[3,3 ];   brd2[1,4 ] = brd[1,4 ];   brd2[2,4 ] = brd[2,4 ];
                brd2[3,5 ] = brd[3,5 ];   brd2[1,6 ] = brd[1,6 ];   brd2[2,6 ] = brd[2,6 ];
                brd2[3,6 ] = brd[3,6 ];   brd2[3,8 ] = brd[3,8 ];   brd2[2,9 ] = brd[2,9 ];
                brd2[4,2 ] = brd[4,2 ];   brd2[5,2 ] = brd[5,2 ];   brd2[4,4 ] = brd[4,4 ];
                brd2[5,4 ] = brd[5,4 ];   brd2[6,5 ] = brd[6,5 ];   brd2[4,7 ] = brd[4,7 ];
                brd2[4,8 ] = brd[4,8 ];   brd2[6,8 ] = brd[6,8 ];   brd2[5,9 ] = brd[5,9 ];
                brd2[6,9 ] = brd[6,9 ];   brd2[9,1 ] = brd[9,1 ];   brd2[7,2 ] = brd[7,2 ];
                brd2[8,3 ] = brd[8,3 ];   brd2[9,3 ] = brd[9,3 ];   brd2[9,5 ] = brd[9,5 ];
                brd2[9,7 ] = brd[9,7 ];   brd2[7,8 ] = brd[7,8 ];   brd2[8,8 ] = brd[8,8 ];
                brd2[7,9 ] = brd[7,9 ];   brd2[8,9 ] = brd[8,9  ];   
                
            }
            if (a == 3)
            {
                brd2[1,1 ] = brd[1,1 ];   brd2[2,1 ] = brd[2,1 ];   brd2[3,2 ] = brd[3,2 ];
                brd2[3,3 ] = brd[3,3 ];   brd2[3,4 ] = brd[3,4 ];   brd2[2,5 ] = brd[2,5 ];
                brd2[1,6 ] = brd[1,6 ];   brd2[2,7 ] = brd[2,7 ];   brd2[3,7 ] = brd[3,7 ];
                brd2[1,9 ] = brd[1,9 ];   brd2[2,9 ] = brd[2,9 ];   brd2[6,1 ] = brd[6,1 ];
                brd2[4,2 ] = brd[4,2 ];   brd2[3,3 ] = brd[3,3 ];   brd2[3,4 ] = brd[3,4 ];
                brd2[2,5 ] = brd[2,5 ];   brd2[1,6 ] = brd[1,6 ];   brd2[2,7 ] = brd[2,7 ];
                brd2[3,7 ] = brd[3,7 ];   brd2[1,9 ] = brd[1,9 ];   brd2[2,9 ] = brd[2,9 ];
                brd2[6,1 ] = brd[6,1 ];   brd2[4,2 ] = brd[4,2 ];   brd2[5,2 ] = brd[5,2 ];
                brd2[5,3 ] = brd[5,3 ];   brd2[5,4 ] = brd[5,4 ];   brd2[5,6 ] = brd[5,6 ];
                brd2[4,8 ] = brd[4,8 ];   brd2[5,8 ] = brd[5,8 ];   brd2[7,2 ] = brd[7,2 ];
                brd2[9,2 ] = brd[9,2 ];   brd2[7,3 ] = brd[7,3 ];   brd2[9,3 ] = brd[9,3 ];
                brd2[9,4 ] = brd[9,4 ];   brd2[8,6 ] = brd[8,6 ];   brd2[8,7 ] = brd[8,7 ];
                brd2[8,7 ] = brd[8,7 ];   brd2[8,8 ] = brd[8,8 ];   brd2[7,9 ] = brd[7,9 ];
                brd2[8,9 ] = brd[8,9 ];   
            }
            if (a == 4)
            {
                brd2[2,1 ] = brd[2,1 ];   brd2[3,1 ] = brd[3,1 ];   brd2[2,2 ] = brd[2,2 ];
                brd2[2,4 ] = brd[2,4 ];   brd2[1,6 ] = brd[1,6 ];   brd2[2,6 ] = brd[2,6 ];
                brd2[2,7 ] = brd[2,7 ];   brd2[1,8 ] = brd[1,8 ];   brd2[1,9 ] = brd[1,9 ];
                brd2[6,1 ] = brd[6,1 ];   brd2[4,2 ] = brd[4,2 ];   brd2[4,3 ] = brd[4,3 ];
                brd2[5,3 ] = brd[5,3 ];   brd2[5,4 ] = brd[5,4 ];   brd2[6,5 ] = brd[6,5 ];
                brd2[5,6 ] = brd[5,6 ];   brd2[4,8 ] = brd[4,8 ];   brd2[6,8 ] = brd[6,8 ];
                brd2[8,2 ] = brd[8,2 ];   brd2[8,3 ] = brd[8,3 ];   brd2[7,4 ] = brd[7,4 ];
                brd2[8,4 ] = brd[8,4 ];   brd2[8,5 ] = brd[8,5 ];   brd2[9,7 ] = brd[9,7 ];
                brd2[7, 8] = brd[7, 8]; brd2[7, 9] = brd[7, 9]; brd2[3, 9] = brd[3, 9]; 
                
            }
            if (a == 5)
            {
                brd2[3,1 ] = brd[3,1 ];   brd2[2,3 ] = brd[2,3 ];   brd2[3,3 ] = brd[3,3 ];
                brd2[1,4 ] = brd[1,4 ];   brd2[1,5 ] = brd[1,5 ];   brd2[2,5 ] = brd[2,5 ];
                brd2[2,6 ] = brd[2,6 ];   brd2[2,7 ] = brd[2,7 ];   brd2[3,7 ] = brd[3,7 ];
                brd2[2,8 ] = brd[2,8 ];   brd2[5,1 ] = brd[5,1 ];   brd2[5,2 ] = brd[5,2 ];
                brd2[4,3 ] = brd[4,3 ];   brd2[5,3 ] = brd[5,3 ];   brd2[4,4 ] = brd[4,4 ];
                brd2[6,4 ] = brd[6,4 ];   brd2[4,6 ] = brd[4,6 ];   brd2[5,8 ] = brd[5,8 ];
                brd2[5,9 ] = brd[5,9 ];   brd2[8,1 ] = brd[8,1 ];   brd2[9,1 ] = brd[9,1 ];
                brd2[7,2 ] = brd[7,2 ];   brd2[8,2 ] = brd[8,2 ];   brd2[8,4 ] = brd[8,4 ];
                brd2[7,5 ] = brd[7,5 ];   brd2[8,6 ] = brd[8,6 ];   brd2[7,8 ] = brd[7,8 ];
                brd2[7,9 ] = brd[7,9 ];   brd2[8,9 ] = brd[8,9 ];   brd2[9,9 ] = brd[9,9 ];

            }
            #endregion

            MakeSprites();
            UpdateScreen();

        }
    
        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawImage(bmp1, 0, 0);
        }
        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            int ch2 = 49;
            ch = e.KeyValue;
            ch2 = ch - 48;
            brd2[by2, bx2] = ch2;
            UpdateScreen();
        }
        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;

            bx = mx / bsize - 4;
            by = my / bsize;



            UpdateScreen();
        }
        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            bx2 = bx;
            by2 = by;
            //brd[bx, by] = bx;
            if (bx == bx4 && by == by4)
            {
                bx4 = 0; by4 = 0;
            }



            UpdateScreen();
        }

        private void ShufflePieces()
        {
            int a = 0;
            int b = 0;
            int p1 = 0;
            int p2 = 0;
            int p3 = 0;
            int p4 = 0; 
            int p5 = 0;
            int p6 = 0;
            int p7 = 0;
            int p8 = 0;
            int p9 = 0;

            
            p1 = rnd.Next(1, 10);
            while (a < 10)
            {
                p2 = rnd.Next(1, 10);
                a = a + 1;
                if (p2 != p1) break;
            }
            a = 0;
            while (a<20)
            {
                p3 = rnd.Next(1, 10);
                a = a + 1;
                if (p3 != p1 && p3 != p2) break;
            }
            a = 0;
            while (a < 20)
            {
                p4 = rnd.Next(1, 10);
                a = a + 1;
                if (p4 != p1 && p4 != p2 && p4 != p3) break;
            }
            a = 0;
            while (a < 20)
            {
                p5 = rnd.Next(1, 10);
                a = a + 1;
                if (p5 != p1 && p5!=p2 && p5 != p3 && p5!= p4) break;
            }
            while (a < 40)
            {
                p6 = rnd.Next(1, 10);
                a = a + 1;
                if (p6 != p1 && p6 != p2 && p6 != p3 && p6 != p4 && p6 != p5) break;
            }
            while (a < 40)
            {
                p7 = rnd.Next(1, 10);
                a = a + 1;
                if (p7 != p1 && p7 != p2 && p7 != p3 && p7 != p4 && p7 != p5 && p7!= p6) break;
            }
            while (a < 40)
            {
                p8 = rnd.Next(1, 10);
                a = a + 1;
                if (p8 != p1 && p8 != p2 && p8 != p3 && p8 != p4 && p8 != p5 && p8 != p6 && p8 != p7) break;
            }
            while (a < 60)
            {
                p9 = rnd.Next(1, 10);
                a = a + 1;
                if (p9 != p1 && p9 != p2 && p9 != p3 && p9 != p4 && p9 != p5 && p9 != p6 && p9 != p7 && p9 != p8 ) break;
            }
            
            a = 1;
            b = 1;
            while (b < 10)
            {
                while (a < 10)
                {  
                    switch(brd[a,b])
                    {
                        case 1:
                            brd[a, b] = p1;
                            break;
                        case 2:
                            brd[a,b] = p2;
                            break;
                        case 3:
                            brd[a,b]=p3;
                            break;
                        case 4:
                            brd[a,b]=p4;
                            break;
                        case 5:
                            brd[a,b]=p5;
                            break;
                        case 6:
                            brd[a,b]=p6;
                            break;
                        case 7 :
                            brd[a,b]=p7;
                            break;
                        case 8:
                            brd[a,b]=p8;
                            break ;
                        case 9:
                            brd[a, b] = p9;
                            break;
                        default:
                            break;

                    }
                    a = a + 1;
                }
                a = 1;
                b = b + 1;
            }
        }

        private void MakeBoard() //     size48 9x 
        {
            
            z.FillRectangle(br5, 228, 36, 456, 456);
            z.FillRectangle(redbr, 236, 44, 441, 441);
            z.FillRectangle(br4, 238, 46, 436, 436);
            
          
        }
        private void MakeGrid()                    
        {
            int x = 0;
            int y = 0;
            int a = 0;
          while (a < 10)
            {
               
                z.DrawLine(whitepen, 240+x, 48, 240+x, 480); // vertical
                if (a == 3 | a == 6) z.DrawLine(blackpen, 240 + x, 48, 240 + x, 480);
                if (a == 3 | a== 6 ) z.DrawLine(darkbluepen, 239 + x, 48, 239 + x, 480);
                if (a == 3 | a== 6 ) z.DrawLine(darkbluepen, 241 + x, 48, 241 + x, 480);
                if (a == 0 | a == 9) z.DrawLine(darkbluepen, 240 + x, 48, 240 + x, 480);
                if (a == 0 | a == 9) z.DrawLine(darkbluepen, 239 + x, 48, 239 + x, 480);
                if (a == 0 | a == 9) z.DrawLine(darkbluepen, 241 + x, 48, 241 + x, 480);
                a = a + 1;
                x = x + 48;
            }
            a = 0;
            while (a < 10)
            {
                z.DrawLine(whitepen, 240 , 48+y, 672, 48+y); // Horizontal
                if (a == 3 | a == 6) z.DrawLine(blackpen, 240, 48 + y, 672, 48 + y);
                if (a == 3 | a == 6) z.DrawLine(darkbluepen, 240, 47 + y, 672, 47 + y);
                if (a == 3 | a == 6) z.DrawLine(darkbluepen, 240, 49 + y, 672, 49 + y);
                if (a == 0 | a == 9) z.DrawLine(darkbluepen, 240, 48 + y, 672, 48 + y);
                if (a == 0 | a == 9) z.DrawLine(darkbluepen, 240, 47 + y, 672, 47 + y);
                if (a == 0 | a == 9) z.DrawLine(darkbluepen, 240, 49 + y, 672, 49 + y);
                a = a + 1;
                y = y + 48;
            }
             a = 0;
             x = 0;
            while (a < 10)
            {

                // vertical
                if (a == 3 | a == 6) z.DrawLine(blackpen, 240 + x, 48, 240 + x, 480);
                if (a == 3 | a == 6) z.DrawLine(darkbluepen, 239 + x, 48, 239 + x, 480);
                if (a == 3 | a == 6) z.DrawLine(darkbluepen, 241 + x, 48, 241 + x, 480);
                if (a == 0 | a == 9) z.DrawLine(darkbluepen, 240 + x, 48, 240 + x, 480);
                if (a == 0 | a == 9) z.DrawLine(darkbluepen, 239 + x, 48, 239 + x, 480);
                if (a == 0 | a == 9) z.DrawLine(darkbluepen, 241 + x, 48, 241 + x, 480);
                a = a + 1;
                x = x + 48;
            }
    }
        private void MakeSprites()                 
        {
            b1.FillRectangle(br4, 2.0F, 2.0F, 46.0F, 46.0F);
            b2.FillRectangle(br4, 2.0F, 2.0F, 46.0F, 46.0F);
            b3.FillRectangle(br4, 2.0F, 2.0F, 45.0F, 45.0F);
            b4.FillRectangle(br4, 2.0F, 2.0F, 46.0F, 46.0F);
            b5.FillRectangle(br4, 2.0F, 2.0F, 46.0F, 46.0F);
            b6.FillRectangle(br4, 2.0F, 2.0F, 46.0F, 46.0F);
            b7.FillRectangle(br4, 2.0F, 2.0F, 46.0F, 46.0F);
            b8.FillRectangle(br4, 2.0F, 2.0F, 46.0F, 46.0F);
            b9.FillRectangle(br4, 2.0F, 2.0F, 46.0F, 46.0F);

            b1.DrawString("1", font30, Brushes.Black, 6, 2);
            b2.DrawString("2", font30, Brushes.Black, 6, 2);
            b3.DrawString("3", font30, Brushes.Black, 6, 2);
            b4.DrawString("4", font30, Brushes.Black, 6, 2);
            b5.DrawString("5", font30, Brushes.Black, 6, 2);
            b6.DrawString("6", font30, Brushes.Black, 6, 2);
            b7.DrawString("7", font30, Brushes.Black, 6, 2);
            b8.DrawString("8", font30, Brushes.Black, 6, 2);
            b9.DrawString("9", font30, Brushes.Black, 6, 2);

            b10.FillRectangle(br3, 0.0F, 0.0F, 48.0F, 48.0F);
            b11.FillRectangle(redbr, 0.0F, 0.0F, 48.0F, 48.0F);
        }
       
        private void UpdateScreen()
        {

            z.FillRectangle(br2, 0.0F, 0.0F, 800.0F, 600.0F);
            //brd[2, 10] = piece1;
            UpdateScreen1();
           // UpdateScreen2();
           // UpdateScreen3();
           // UpdateScreen4();
           // UpdateScreen5();
            //z.DrawString("Score  =", myfont, Brushes.White, 20, 500);
            z.DrawString(cnt.ToString(), myfont, Brushes.White, 110, 500);
           // z.DrawString(bx.ToString(), myfont, Brushes.White, 20, 460);
           // z.DrawString(by.ToString(), myfont, Brushes.White, 20, 480);
           // z.DrawString(ch.ToString(), myfont, Brushes.White, 50, 460);
            if( cnt < 500 )Instructions();
            if (cnt > 500 ) EndPrint();
            MakeBoard();
            UpdateScreen1();
            MakeGrid();
            Invalidate();
            Update();

        }
        private void UpdateScreen1()
        {

            int x = 1;
            int y = 1;
            int a = 1;
            int b = 1;
            int x1 = 240; // offsets
            int y1 = 48;
            if(bx2>0)z.DrawImage(bm10, (48*bx2-48) + x1, (48*by2-48) + y1);
            if (bx4 > 0) z.DrawImage(bm11, (48 * bx4 - 48) + x1, (48 * by4 - 48) + y1);
            while (a < 10)
            {
                while (b < 10) // 51,  x stays < 800
                {
                  

                    if (brd2[a, b] == 1) { z.DrawImage(bm1, x+x1, y+y1); }
                    if (brd2[a, b] == 2) { z.DrawImage(bm2, x+x1, y+y1); }
                    if (brd2[a, b] == 3) { z.DrawImage(bm3, x+x1, y+y1); }
                    if (brd2[a, b] == 4) { z.DrawImage(bm4, x+x1, y+y1); }
                    if (brd2[a, b] == 5) { z.DrawImage(bm5, x+x1, y+y1); }
                    if (brd2[a, b] == 6) { z.DrawImage(bm6, x+x1, y+y1); }
                    if (brd2[a, b] == 7) { z.DrawImage(bm7, x+x1, y+y1); }
                    if (brd2[a, b] == 8) { z.DrawImage(bm8, x+x1, y+y1); }
                    if (brd2[a, b] == 9) { z.DrawImage(bm9, x+x1, y+y1); }
                  
                    x = x + bsize;
                    b = b + 1;
                  
                }
                a = a + 1;
                b = 1;
                x = 1;
                y = y + bsize;
            }


        }
        private void Instructions()
        {

            z.DrawString(" The object of this game is to fill ", font10, Brushes.White, 0, 100);
            z.DrawString("the board with the correct set of ", font10, Brushes.White, 0, 118);
            z.DrawString("number digits, 1 through 9. ", font10, Brushes.White, 0, 136);
            z.DrawString(" Every row should have nine different ", font10, Brushes.White, 0, 154);
            z.DrawString("digits, every column should have nine  ", font10, Brushes.White, 0, 172);
            z.DrawString("different digits and every 9 by 9 ", font10, Brushes.White, 0, 190);
            z.DrawString("square should have 9 different digits. ", font10, Brushes.White, 0, 208);
            z.DrawString(" Click a square with the mouse to ", font10, Brushes.White, 0, 226);
            z.DrawString("select it and then hit a number key ", font10, Brushes.White, 0, 244);
            z.DrawString("to fill it. ", font10, Brushes.White, 0, 262);
            z.DrawString(" Wrong answers will eventually turn ", font10, Brushes.White, 0, 280);
            z.DrawString("red and they can be changed with the ", font10, Brushes.White, 0, 298);
            z.DrawString("mouse. ", font10, Brushes.White, 0, 316);
        }
        private void Print(string str, int x1, int x2)
        {

            z.DrawString(str, font7, Brushes.White, x1, x2);
        }
        private void EndPrint()
        {

            Print("This program brought to you by:", 5, 60);
            Print("Grace Church of the Nazarene", 5, 80);
            Print("2302 Highland Avenue", 5, 100);
            Print("Columbia, Tennessee 931-388-4788", 5, 120);
            
            //Print " "
            //Print " "
            Print("See our website at:", 5, 150);
            Print("www.columbiagrace.org", 5, 170);
            //Print " "
            //Print " "
            Print("Phillippians 4:8  NKJV", 5, 210);
            //Print
            Print("Finally, brethren, whatever things are true,", 5, 240);
            Print("whatever things are noble,whatever things are just,", 5, 260);
            Print("whatever things are pure, whatever things are lovely,", 5, 280);
            Print("whatever things are of good report, if there is any", 5, 300);
            Print("virtue and if there is anything praiseworthy -", 5, 320);
            Print(" meditate on these things.", 5, 340);

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            bx3 = bx3 + 1;
            if (bx3 > 9)
            {
                bx3 = 1;
                by3 = by3 + 1;
                if (by3 > 9) by3 = 1;
            }
            if (brd2[by3, bx3] > 0 && brd2[by3, bx3] != brd[by3, bx3])
            {
                bx4 = bx3; by4 = by3;
            }
            UpdateScreen();
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            cnt = cnt + 1;
        }
    }
    // @@@@@@@@@@@@@@@@@@@@@@@@ END OF FORM1 @@@@@@@@@@@@@@@@@@@@@@@@@@@@
    public class Sounds
    {
        [DllImport("WinMM.dll")]

        public static extern bool PlaySound(string fname, int Mod, int flag);

        // these are the SoundFlags we are using here, check mmsystem.h for more
        public static int SND_PURGE = 0x0040; // purge non-static events
        public static int SND_ASYNC = 0x0001; // play asynchronously
        public static int SND_SYNC = 0x0000; // play synchronously (default)
        public static int SND_NODEFAULT = 0x0002; // silence (!default) if sound not found
        public static int SND_MEMORY = 0x0004; // pszSound points to a memory file
        public static int SND_LOOP = 0x0008; // loop the sound until next sndPlaySound
        public static int SND_NOSTOP = 0x0010; // don't stop any currently playing sound
        public static int SND_NOWAIT = 0x00002000; // don't wait if the driver is busy
        public static int SND_ALIAS = 0x00010000; // name is a registry alias
        public static int SND_ALIAS_ID = 0x00110000; // alias is a predefined ID
        public static int SND_FILENAME = 0x00020000; // name is file name
        public static int SND_RESOURCE = 0x00040004; // name is resource name or atom

        public static void Play(string fname)
        {
            //StopPlay();
            PlaySound(fname, 0, SND_ASYNC | SND_NODEFAULT | SND_FILENAME | SND_NOWAIT);
        }

        public static void Stop()
        {
            PlaySound(null, 0, SND_PURGE);
        }
    }
}