using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;


// This Form is for 3d practice

namespace Template3d
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        int mx = 1;   // mouse position-pixels
        int my = 1;
        int bx = 1;   // mouse position-blocks
        int by = 1;
        int r1 = 1;   // random numbers
        int r2 = 1;
        int bsize = 50;  // block size

        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(0, 0, 40));
        Brush br3 = new SolidBrush(Color.FromArgb(0, 0, 200));
        Font myfont = new Font("Arial", 14.0F);
        Font font10 = new Font("Arial", 10.0F);
        Random rnd = new Random();

        //@@@@@@@ Bitmaps @@@@@@@@@@@
        static Bitmap bmp1 = new Bitmap(800, 600);
        Graphics z = Graphics.FromImage(bmp1);
        //Image sp1 = (Image)(new Bitmap(Template3d.Properties.Resources.AAT));
        private void Form1_Load(object sender, EventArgs e)
        {
            z.FillRectangle(br2, 0.0F, 0.0F, 800.0F, 600.0F);
            Invalidate();
            Update();

        }

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;

            bx = mx / bsize + 1;
            by = my / bsize + 1;

            
            r1 = rnd.Next(1, 7);
            r2 = rnd.Next(1, 7);
            UpdateScreen();
        }

        private void UpdateScreen()
        {
            z.FillRectangle(br2, 0.0F, 0.0F, 800.0F, 600.0F);
            z.FillRectangle(br3, mx-20, my-20, 10, 10);

           // z.DrawString(bx.ToString(), myfont, Brushes.White, 200, 460);
           // z.DrawString(by.ToString(), myfont, Brushes.White, 200, 480);
            Invalidate();
            Update();
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {

        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawImage(bmp1, 0, 0);
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;
            UpdateScreen();

        }

    }
}