using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;


// This Form is for 3d practice

namespace Template3d
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.SetStyle(ControlStyles.AllPaintingInWmPaint | ControlStyles.Opaque, true);
        }
        int mx = 1;   // mouse position-pixels
        int my = 1;
        int bx = 1;   // mouse position-blocks
        int by = 1;
        int r1 = 1;   // random numbers
        int r2 = 1;
        int key1 = 1;
        Single num1 = 1;
        Single num2 = 0;
        Single num3 = 1;
        int bsize = 50;  // block size
        int ax = 0;
        int ay = 450;
        Single angle = 0;// 0-360
        Single angle2 = 90; // 0-800
        Pen pen1 = new Pen(Color.White);
        Brush br1 = new SolidBrush(Color.Black);
        Brush br2 = new SolidBrush(Color.FromArgb(0, 0, 40));
        Brush br3 = new SolidBrush(Color.FromArgb(0, 0, 200));
        Font myfont = new Font("Arial", 14.0F);
        Font font10 = new Font("Arial", 10.0F);
        Random rnd = new Random();
        //Graphics g = Graphics.FromHwnd(Form1.Handle);
        //@@@@@@@ Bitmaps @@@@@@@@@@@
        static Bitmap bmp1 = new Bitmap(800, 600);
        Graphics z = Graphics.FromImage(bmp1);
        Image sp1 = (Image)(new Bitmap(Template3d.Properties.Resources.AAT));

        private void Form1_Load(object sender, EventArgs e)
        {
            z.FillRectangle(br2, 0.0F, 0.0F, 800.0F, 600.0F);
            
            Invalidate();
            Update();

        }

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;

            bx = mx / bsize + 1;
            by = my / bsize + 1;

            
            r1 = rnd.Next(1, 7);
            r2 = rnd.Next(1, 7);
            UpdateScreen();
        }

        private void UpdateScreen()
        {
            //  vertical center line =  x1,y1 - x1,y2
            //  vertical right line  =  x2,y1 - x2,y2
            Single x1 = 400;     // center front  x point            
            Single x2 = 600;     // right front x point              
            Single x3 = 400;     // back left x point            
            Single x4 = 600;     // back right x point

            Single y1 = 200;     // top center y point     
            Single y2 = 400;     // bottom center y point
            Single y3 = 200;
            Single y4 = 400;
            Single y5 = 200;     // back left bottom y point
            Single y6 = 400;     // back left top y point
            Single y7 = 100;     // back right upper y point

            Single dxr = 200;      // offset of x on right  (distance)
            Single dyr = 0;     // offset of y on  right
            Single dxl = 0;      // offset of x on left  (distance)
            Single dyl = 100;      // y offset on left
            Single nn = 50;
            PointF[] pt1 = { new PointF(140, 130), new PointF(155, 145), new PointF(135, 155) };

            
           
                                // num1 = Cosine of angle .999-0   angle = 0-90 deg
                                // num2 = Sine of angle   0-.999
            dxr = 200 * num1;    // dxr = distance from center to right corner
            dxl = 200 * num2;    // dxl = distance from center to left corner
            dyr = nn * num2;   //  dyr = offset to back-right corner cosine
            dyl = nn * num1;   //  dyr = offset to back-right corner

            x2 = x1 + dxr;   // x coordinate of right line
            x3 = x1 - dxl;    // x coordinate of left line
            x4 = x1 + dxr - dxl;

            y3 = y1 - dyr;   // y3 = top right point
            y4 = y2 - dyr;   // y4 = bottom right point
            
            y5 = y1 - dyl;   // y3 = top right point
            y6 = y2 - dyl;   // y4 = bottom right point

            y7 = y1 - dyr - dyl;

            x1 = x1 * ( Single ) .85; // Adjust x because of screen shape
            x2 = x2 * ( Single ) .85;
            x3 = x3 * (Single).85;
            x4 = x4 * (Single).85;
            PointF[] pt2 = { new PointF(x1, y1), new PointF(x2, y3), new PointF(x2, y4), new PointF(x1, y2) };
            PointF[] pt3 = { new PointF(x3, y5), new PointF(x1, y1), new PointF(x1, y2), new PointF(x3, y6) };
            PointF[] pt4 = { new PointF(x3, y5), new PointF(x4, y7), new PointF(x2, y3), new PointF(x1, y1) };
            PointF[] pt5 = { new PointF(x1, y1), new PointF(x2, y3), new PointF(x1, y2) };
            PointF[] pt6 = { new PointF(ax, ay), new PointF(ax+96, ay), new PointF(ax, ay+110) };

            z.Clear(Color.FromArgb(0, 0, 0));
            z.FillPolygon(Brushes.Red, pt2);
            z.FillPolygon(Brushes.Blue, pt3);
            z.FillPolygon(Brushes.Green, pt4);

            z.DrawImage(sp1, pt5);
            z.DrawImage(sp1, pt6);
            //z.DrawImage(sp1, ax,ay);
                z.DrawLine(pen1, x1, y1, x1, y2); // vertical 1 
                z.DrawLine(pen1, x2, y3, x2, y4);//  vertical 2

                z.DrawLine(pen1, x1, y1, x2, y3); // Horizontal 1 
                z.DrawLine(pen1, x1, y2, x2, y4);//  Horizontal 2

                z.DrawLine(pen1, x3, y5, x3, y6); // vertical 3
                z.DrawLine(pen1, x1, y1, x3, y5); // Horizontal 3 
                z.DrawLine(pen1, x1, y2, x3, y6); // Horizontal 4

                z.DrawLine(pen1, x3, y5, x4, y7); // Horizontal 5 
                z.DrawLine(pen1, x4, y7, x2, y3);//  Horizontal 6


            
            
            //z.DrawString(angle.ToString(), myfont, Brushes.White, 20, 440);
            //z.DrawString(num1.ToString(), myfont, Brushes.White, 20, 460);
            //z.DrawString(num2.ToString(), myfont, Brushes.White, 20, 480);
            Invalidate();
            Update();
        }

       

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            //e.Graphics.Clear(Color.FromArgb(0, 0, 50));
            e.Graphics.DrawImage(bmp1, 0, 0);
            //e.Graphics.DrawLine(pen1, 0,200, 800, 200);
           
           // e.Graphics.DrawImage(sp1,ax,bx);
        }
        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            key1 = (int) e.KeyCode;
            if (key1 == 38) angle = angle + .5F;
            if (key1 == 40) angle = angle - .5F;
            if (angle < 0) angle = 0;
            if (angle > 90) angle = 90;
            
           num1 =  Cosine(angle);
           num2 =  Sine(angle);
          
        }
        private Single ConvertDegreesToRadians(Single degrees)
        {

            //double radians = (Math.PI / 180) * degrees;
            Single radians = (Single)(3.1415 / 180) * degrees;
            return (radians);

        }
        private Single Sine(Single a)  // get the sine function using degrees
        {                               // a = degrees
             
            Single b = 1;
            b =  ConvertDegreesToRadians(a);
            b = (Single) Math.Sin(b);
            
            return b;
        }
        private Single Cosine(Single a)  // get the sine function using degrees
        {                               // a = degrees

            Single b = 1;
            b = ConvertDegreesToRadians(a);
            b = (Single)Math.Cos(b);

            return b;
        }


        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;
            
          
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
         
            ax = ax + 1;
            if (ax > 800) ax = 1;
            UpdateScreen();
            //Graphics g = Graphics.FromHwnd(this.Handle);
            //e.Graphics.DrawImage(bmp1, 0, 0);
           
        }

      


    }
}